#!/bin/sh
NS_HOST=myHD
APKG_PATH=/usr/local/AppCentral/${NS_HOST}
APKG_FOLDER=/usr/local
MYHD_BIN=${APKG_PATH}/bin

BLUE="\033[0;36m"
NC="\033[0m"
RED="\033[0;31m"
BOLD="\033[1m"
UNBOLD="\033[0m"
WGREEN="<font color=#00FF00>"
WRED="<font color=#FF0000>"
WBLUE="<font color=#0000FF>"
WBLACK="<font color=#000000>"
WNC="</font>"
WBOLD="<b>"
WUNBOLD="</b>"

usage(){
	echo -e "$(basename $0) Usage : Color signification ${BLUE}Tested${NC} / ${RED}Tested BUT take care${NC} / Not_tested or Not_available_for_now"
	echo "====================="
	echo -e "$(basename $0) ${BLUE}start|stop|restart|status $NC"
	echo -e "$(basename $0) ${BLUE}list_all_installed_apkg $NC list MH MH16 and MH18 installed APKG"
	echo -e "$(basename $0) ${BLUE}get_App_available ${NC}... list MH APKG available for installation in ${NS_HOST} from Father_Mande App. Store"
	echo -e "$(basename $0) ${BLUE}install_App_from_store [MH-xxx|MH16-xxx|MH18-xxx] VERSION ${NC}... install MHxxx APKG Version yy from Father_Mande App. Store"
	# echo -e "$(basename $0) ${BLUE}remove_application [MH-xxx|MH16-xxx|MH18-xxx] ... remove it from NAS Applications" 
	echo "====================="
	echo "--------------------- DANGEROUS uninstall ... it's INTERACTIVE so wait for question and read carefully output text ..."
	echo -e "$(basename $0) ${RED}uninstall_${NS_HOST} ${NC}... ${BLUE}TOTAL REMOVE${NC} ${NS_HOST} INCLUDING ALL associated QPKGs THEN ALL Ubuntu env. THEN ${NS_HOST} itself"
	echo -e "$(basename $0) ${RED}uninstall_all_${NS_HOST}_APKG ${NC}... ${NS_HOST} remove ALL associated APKGs "
	echo -e "$(basename $0) ${RED}uninstall_Ubuntu_environment ${NC}... ${NS_HOST} remove ALL Ubuntu environment"
	echo "====================="
	# echo -e "$(basename $0) reinstall_ubuntu_env ... reinstall ${UVER} Ubuntu from network or pre-downloaded files"
	echo -e "$(basename $0) ${BLUE}list_ubuntu_env ${NC}... ${NS_HOST} list Ubuntu version used at this time"
	echo -e "$(basename $0) ${BLUE}switch_ubuntu_env 1804|1604 ${NC}... ${NS_HOST} switch to new Ubuntu version (1604 to 1804 or reverse"
	echo "====================="
	echo -e "$(basename $0) ${BLUE}enter_as_root ${NC}... enter in ${NS_HOST} as root user"
	echo -e "$(basename $0) ${BLUE}enter_as_user USER_NAME ${NC}... enter in ${NS_HOST} as USER_NAME user"
	echo "====================="
	echo -e "$(basename $0) ${BLUE}apt_upgrade_package ${NC}... run apt-get update, upgrade and restart based on ${NS_HOST}.conf"
	# echo -e "$(basename $0) ${BLUE}install_${NS_HOST}_package TAR_FILE_NAME [PKG_NAME] ${NC}... install or update external packages (suffix .${NS_HOST} MUST be PRESENT in tar file name)"
	echo "====================="
	echo -e "$(basename $0) ${BLUE}set_sshd_port PORT ${NC}.... set the port use by dropbear for next ${NS_HOST} dropbear server start : PORT is not verified take care"
	echo -e "$(basename $0) ${BLUE}restart_dropbear ${NC}... use it if you change port or keys of ${NS_HOST} dropbear server"
	echo -e "$(basename $0) ${BLUE}reset_ssh_keys ${NC}... recreate the ssh keys and install them in ${NS_HOST} user folder"
	echo "====================="
	echo -e "$(basename $0) ${BLUE}list_mounted_folder ${NC}... list all mounted folder (so also temporary)"
	echo -e "$(basename $0) ${BLUE}list_valid_folder ${NC}... list ALL valid folder able to be mounted in ${NS_HOST} and already selected"
	echo -e "$(basename $0) ${BLUE}add_include_folder [MOUNT_FOLDER_PATH_IN_${NS_HOST}] ${NC}...(form : /share/xxxx ) permanent (at start) add folder to be mounted"
	echo -e "$(basename $0) ${BLUE}remove_include_folder FOLDER_PATH ${NC}... (like /share/xxx )"
	echo -e "$(basename $0) ${BLUE}list_include_folder ${NC}... list ALL folder permanently mounted in ${NS_HOST}"
	echo -e "$(basename $0) ${BLUE}list_temporary_mounted_folder ${NC}... list of temporary mounted folder"
	echo -e "$(basename $0) ${BLUE}mount_temporary_folder FOLDER ${NC}... mount temporary folder (/share/xxx)"
	echo -e "$(basename $0) ${BLUE}umount_temporary_folder FOLDER ${NC}... umount temporary folder (/share/xxx)"
	echo "====================="
	#echo -e "$(basename $0) ${BLUE}list_user_define ${NC}... list users already define in ${NS_HOST} (astr = admin)"
	#echo -e "$(basename $0) ${BLUE}clone_user USER_QTS_TO_MOVE ${NC}... clone an existing QTS user to ${NS_HOST}"
	#echo -e "$(basename $0) ${BLUE}change_adm_password USER_NAME NEW_PASSWORD ${NC}... change user password in A.D.M. environment"
	#echo -e "$(basename $0) ${BLUE}change_${NS_HOST}_password USER_NAME NEW_PASSWORD ${NC}... change user password in ${NS_HOST} environment"
	#echo -e "$(basename $0) ${BLUE}change_all_password USER_NAME NEW_PASSWORD ${NC}... change user password in A.D.M. AND ${NS_HOST} environment"
	# echo "====================="
	echo -e "$(basename $0) ${BLUE}clean_for_backup [full] ${NC}... clear man, doc and clean apt cache : full : add an autoclean (so reduce drasticaly backup size)"
	echo "------------------- autoclean force to RE download packages when update / install ... so NO return to previous version NO some tools (tweek for ex.)"
	echo -e "$(basename $0) ${BLUE}backup_env [full] ${NC}... save snapshot of $UVER Ubuntu env. incremental or new full / home folder / scipts folder"
	echo -e "$(basename $0) ${BLUE}backup_home ${NC}... save ONLY the home folder (all users) to keep settings for applications ... "
	echo -e "$(basename $0) ${BLUE}set_backup_folder PATH_TO_FOLDER ${NC}... change the default or actual backup FOLDER (default is $(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST}  BACKUP_FOLDER)"
	echo -e "$(basename $0) ${BLUE}list_backup_folder ${NC}... list the actual backup_fodler"
	echo "====================="
	echo -e "$(basename $0) ${BLUE}set_update_at_boot [on|off] ${NC}... set on or disable (off) update after start of ${NS_HOST}"
	echo -e "$(basename $0) ${BLUE}set_restart_if_update_require [on|off] ${NC}... set on or disable (off) restart after update of ${NS_HOST}"
	echo "====================="
	echo -e "$(basename $0) ${BLUE}enable_webui ${NC}... enable WebUI interface"
	echo -e "$(basename $0) ${BLUE}disable_webui ${NC}... disable WebUI interface ... so only command line can be used"
	echo -e "$(basename $0) ${BLUE}set_webui_lang LANG  ${NC}... change WebUI language to LANG (ex. en, fr, xx, etc.)"
	echo -e "$(basename $0) ${BLUE}display_actual_webui_lang  ${NC}... actual language in use"
	echo -e "$(basename $0) ${BLUE}list_available_lang_webui  ${NC}... list all language available (complete or partial en is default for missing text) "
	echo -e "$(basename $0) ${BLUE}add_or_update_webui_user USER PASSWORD ${NC}... add if user don't exist or update password if user exit"
	echo -e "$(basename $0) ${BLUE}list_webui_user ${NC}... list ALL user define in pasword protected WebUI"
	echo -e "$(basename $0) ${BLUE}suppress_webui_user USER ${NC}... suppress a user of the list BUT no suppress possible if only ONE user is available "
	echo "====================="
	echo -e "$(basename $0) ${BLUE}list_available_app_for_autorun ${NC}... list MH-xxx MH16-xxx or MH18-xxx available for autorun in ${NS_HOST}"
	echo -e "$(basename $0) ${BLUE}list_my_autorun ${NC}... list MH APKG used for autorun in ${NS_HOST}"
	echo -e "$(basename $0) ${BLUE}set_my_autorun [MH-xxx|MH16-xxx|MH18-xxx|NONE] ${NC}... set ${NS_HOST} autorun to start MHxxxx companion application or NONE to cancel it"
	echo "====================="
	echo -e "$(basename $0) ${BLUE}set_use_jchroot ${NC}... use jchroot with bash (initial version)"
	echo -e "$(basename $0) ${RED}set_use_jinit ${NC}... ${RED}ALPHA ALPHA ALPHA${NC} use NEW jchroot with systemd init (new approach)"
	echo "====================="
}

share_network() {
	cp -p /etc/hosts ${CHROOT_PATH}/etc/
	cp -p /etc/hostname ${CHROOT_PATH}/etc/
	cp -p /etc/resolv.conf ${CHROOT_PATH}/etc/

}

generate_fstab(){
if [ -e $APKG_PATH/fstab_${NS_HOST} ] ; then
	rm -f $APKG_PATH/fstab_${NS_HOST}
fi
### add home as a separate folder (ot save easily user env."
echo "${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_home /home none bind,rw 0,0" > $APKG_PATH/fstab_${NS_HOST}
### add scripts folder (install / run applications) able to be installed from QTS
if [ ! -e ${CHROOT_PATH}/${NS_HOST}_scripts ] ; then
	mkdir ${CHROOT_PATH}/${NS_HOST}_scripts
	chmod 755 ${CHROOT_PATH}/${NS_HOST}_scripts
fi
echo "${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_scripts /${NS_HOST}_scripts none bind,rw 0,0" >> $APKG_PATH/fstab_${NS_HOST}
### new add an exchange folder with QTS
if [ ! -e ${APKG_PATH}/${NS_HOST}_temp ] ; then
	mkdir ${APKG_PATH}/${NS_HOST}_temp
	chmod 777 ${APKG_PATH}/${NS_HOST}_temp
fi 
echo "$APKG_PATH/${NS_HOST}_temp /${NS_HOST}_temp none bind,rw 0,0" >> $APKG_PATH/fstab_${NS_HOST}

# rewrite fstab add using new fstab_include
if [ -e $APKG_PATH/fstab_include ] ; then
	while read -r line
	do
		NEW_FS="$(echo $line | cut -f 1 -d ":")"
		NEW_MNT="$(echo $line | cut -f 2 -d ":")"
		if [ -z "${NEW_MNT}" ] ; then
			NEW_MNT="${NEW_FS}"
		fi
		if [ ! -e "${CHROOT_PATH}/${NEW_MNT}" ] ; then
        	        mkdir -p "${CHROOT_PATH}/${NEW_MNT}"
                	chmod 777 "${CHROOT_PATH}/${NEW_MNT}"
	    fi
		NEW_FS="$(echo "${NEW_FS}" | sed -e 's/ /\\040/g')"
		NEW_MNT="$(echo "${NEW_MNT}" | sed -e 's/ /\\040/g')"
		## To Be Confirm : test readlink if external add mount external before ???
		echo "${NEW_FS} ${NEW_MNT} none bind,rw 0,0" >> $APKG_PATH/fstab_${NS_HOST}
	done < "$APKG_PATH/fstab_include"
fi
}

list_user(){
        echo "LIST of user in ${NS_HOST} :"
        echo "root (NOT Asustor root user but real root ${NS_HOST} user)"
        while read LINE
        do
                if [ $(echo $LINE | cut -f 3 -d ":") -ge 500 ] ; then
                	if [ "$(echo $LINE | cut -f 1 -d ":")" != "nobody" ] ; then
				if [ "$(echo $LINE | cut -f 1 -d ":")" = "astr" ] ; then
					echo "$(echo $LINE | cut -f 1 -d ":") (it's Asustor root user MAPPED as astr user in ${NS_HOST})"
				else
                                       	echo "$(echo $LINE | cut -f 1 -d ":")"
				fi
                        fi
                fi
        done < "${CHROOT_PATH}/etc/passwd"
        echo "End of the list"
}

save_swaps(){
		cat /proc/swaps | grep -v Filename | cut -f 1 -d " " > /tmp/swaps_list
}

restore_swaps(){
	echo "restore swaps /dev/xxx put off by systemd at ${NS_HOST} stop"
	NB=3
	while IFS='' read -r line
	do
		grep -q "$line" /proc/swaps 
		if [ $? -ne 0 ] ; then
			echo "Restore $line swaps"
			swapon -p ${NB} "$line" 
			NB=$((NB-1))
			if [ $NB -lt 0 ] ; then
				break
			fi
		fi
	done < /tmp/swaps_list
}

set_dropbear_port(){
	cp -p ${CHROOT_PATH}/etc/default/dropbear ${CHROOT_PATH}/etc/default/dropbear.prev
	DPORT=$(grep ^DROPBEAR_PORT ${CHROOT_PATH}/etc/default/dropbear | cut -f 2 -d ":")
	CONFPORT=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} DROPBEAR_PORT)
	if [ ${CONFPORT} -eq ${NEWPORT} ] ; then
		echo "Nothing to do it's same PORT value ????"
	else
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} DROPBEAR_PORT ${NEWPORT} 
		sed -i "s/${DPORT}/${NEWPORT}/g" ${CHROOT_PATH}/etc/default/dropbear
	fi
}

manage_adm_infos_keys(){
	echo "get keys from Asportal / get sound def."
	if [ ! -e /root/.ssh ] ; then
		mkdir /root/.ssh
		chmod 700 /root/.ssh
		ln -s /usr/etc/ssh/ssh_host_rsa_key.pub /root/.ssh/id_rsa.pub
		ln -s /usr/etc/ssh/ssh_host_rsa_key /root/.ssh/id_rsa
	else
		if [ ! -e /root/.ssh/id_rsa ] ; then
			ln -s /usr/etc/ssh/ssh_host_rsa_key /root/.ssh/id_rsa
		fi
		if [ ! -e /root/.ssh/id_rsa.pub ] ; then
			ln -s /usr/etc/ssh/ssh_host_rsa_key.pub /root/.ssh/id_rsa.pub
		fi
	fi
	if [ ! -e /home/admin/.ssh ] ; then
		mkdir /home/admin/.ssh
		ln -s /usr/etc/ssh/ssh_host_rsa_key.pub /home/admin/.ssh/id_rsa.pub
		ln -s /usr/etc/ssh/ssh_host_rsa_key /home/admin/.ssh/id_rsa
		chown admin /home/admin/.ssh
		chown admin /home/admin/.ssh/id_rsa
		chown admin /home/admin/.ssh/id_rsa.pub
	else
		if [ ! -e /home/admin/.ssh/id_rsa ] ; then
			ln -s /usr/etc/ssh/ssh_host_rsa_key /home/admin/.ssh/id_rsa
			chown admin /home/admin/.ssh/id_rsa
		fi
		if [ ! -e /home/admin/.ssh/id_rsa.pub ] ; then
			ln -s /usr/etc/ssh/ssh_host_rsa_key.pub /home/admin/.ssh/id_rsa.pub
			chown admin /home/admin/.ssh/id_rsa.pub
		fi
	fi
	
}

start_myserv_by_user(){
	echo "Background interface to solve some launch problems (like AppImage)"
	while read LINE
    do
        if [ $(echo $LINE | cut -f 3 -d ":") -ge 500 ] ; then
			USER_NAME=$(echo $LINE | cut -f 1 -d ":")
            if [ "${USER_NAME}" != "nobody" ] ; then
			echo "Start background interface for user ${USER_NAME}"
				if [ "$CHRT" = "jchroot" ] ; then
					${APKG_PATH}/bin/tmux send-keys -t ${NS_HOST} "/bin/su - ${USER_NAME} -c /${NS_HOST}_scripts/bin/start_myserv.sh" Enter
				else
					/usr/local/bin/${NS_HOST}_user ${USER_NAME} /${NS_HOST}_scripts/bin/start_myserv.sh
				fi
				sleep 1
				#/usr/local/bin/${NS_HOST}_user ${USER_NAME} /${NS_HOST}_scripts/bin/start_myserv.sh 
			fi
        fi
    done < "${CHROOT_PATH}/etc/passwd"
}

copy_adm_authorized_keys(){
	while read LINE
    do
        if [ $(echo $LINE | cut -f 3 -d ":") -ge 500 ] ; then
			USER_NAME=$(echo $LINE | cut -f 1 -d ":")
            if [ "${USER_NAME}" != "nobody" ] ; then
				echo "set keys and files for user ${USER_NAME}"
				if [ "$CHRT" = "jchroot" ] ; then
					${APKG_PATH}/bin/tmux send-keys -t ${NS_HOST} "/bin/su - ${USER_NAME} -c /${NS_HOST}_scripts/bin/update_user.sh" Enter
				else
					/usr/local/bin/${NS_HOST}_user ${USER_NAME} "/${NS_HOST}_scripts/bin/update_user.sh noaudio"
				fi
				sleep 2
			fi
        fi
    done < "${CHROOT_PATH}/etc/passwd"
	### now do it for /root
	if [ "$CHRT" = "jchroot" ] ; then
		${APKG_PATH}/bin/tmux send-keys -t ${NS_HOST} "/bin/cp /${NS_HOST}_scripts/files/authorized_keys /root/.ssh/" Enter
	else
		/usr/local/bin/${NS_HOST}_root "/bin/cp /${NS_HOST}_scripts/files/authorized_keys /root/.ssh/"
	fi
	### ADD here change timezone in Ubuntu env.
	# /usr/local/bin/${NS_HOST}_root "/${NS_HOST}_scripts/bin/update_tz.sh ${TZONE}"
}

copy_chroot_authorized_keys(){
	if [ -e ${CHROOT_PATH}/.keys.tmp ] ; then
		rm -f ${CHROOT_PATH}/.keys.tmp
	fi
	touch ${CHROOT_PATH}/.keys.tmp
	
	if [ "${CHRT}" = "jchroot" ] ; then
		${APKG_PATH}/bin/tmux send-keys -t ${NS_HOST} "/${NS_HOST}_scripts/bin/generate_keys.sh" Enter
		## HERE wait for generate_keys.sh finished
		NB=20
		while [ $NB -gt 0 ]
		do
			if [ -e ${CHROOT_PATH}/.keys.tmp ] ; then
				sleep 3
				NB=$(($NB-1))
			else
				break
			fi
		done
	else
		# jinit simulation of NB perhaps temp if change done no more tmux for jchroot
		/usr/local/bin/${NS_HOST}_root "/${NS_HOST}_scripts/bin/generate_keys.sh"
		if [ -e ${CHROOT_PATH}/.keys.tmp ] ; then
			NB=0
		else
			NB=1
		fi
	fi
	
	if [ $NB -le 0 ] ; then
		echo "==== PROBLEM : KEYS are not generated after 1 minutes"
		echo "==== HUM ERROR ... ${NS_HOST} can't mount temporary folder due to lack of keys ????"
		/usr/sbin/applog --level 1 --package "${NS_HOST}" --event "ssh keys in ${NS_HOST} was NOT generated ... (after waiting 1 minutes) please investigate"
	else
		#
		if [ -e ${CHROOT_PATH}/root/.ssh/id_rsa -a -e ${CHROOT_PATH}/root/.ssh/id_rsa.pub ] ; then
			echo "create or verify authorized_keys for ADM root user"
			if [ -e /root/.ssh ] ; then
				chmod 700 /root/.ssh
			else
				mkdir /root/.ssh
				chmod 700 /root/.ssh
			fi
			if [ -e /root/.ssh/authorized_keys ] ; then
				grep -q "$(cat ${APKG_FOLDER}/.${NS_HOST}/${UVER}/root/.ssh/id_rsa.pub)" /root/.ssh/authorized_keys
				if [ $? -eq 0 ] ; then
					echo "keys for ${NS_HOST} root user is already installed"
				else
					grep -q "${NS_HOST}_root" /root/.ssh/authorized_keys
					if [ $? -eq 0 ] ; then
						sed -i "/${NS_HOST}_root/d" /root/.ssh/authorized_keys
					fi
					cat ${APKG_FOLDER}/.${NS_HOST}/${UVER}/root/.ssh/id_rsa.pub >> /root/.ssh/authorized_keys
				fi
			else
				cat ${APKG_FOLDER}/.${NS_HOST}/${UVER}/root/.ssh/id_rsa.pub > /root/.ssh/authorized_keys
			fi
		else
			echo "HUM ERROR ... ${NS_HOST} can't mount temporary folder due to lack of keys ????"
		fi
	fi
}

init_alsa_audio(){
	echo "Init alsa"
	# /usr/local/bin/${NS_HOST}_root "/usr/sbin/alsactl init"
	if [ "$CHRT" = "jchroot" ] ; then
		${APKG_PATH}/bin/tmux send-keys -t ${NS_HOST} "/usr/sbin/alsactl init" Enter
	else
		/usr/local/bin/${NS_HOST}_root "/usr/sbin/alsactl init"
	fi
}

link_to_exec(){
### initial set_up
	if [ -L /usr/local/bin/${NS_HOST} ] ; then
		rm -f /usr/local/bin/${NS_HOST}
	else
		if [ -e /usr/local/bin/${NS_HOST} ] ; then
			echo "Hum! strange /usr/local/bin/${NS_HOST} is not a link ... whaooh! error error ... "
			exit 1
		fi
	fi
	ln -s ${APKG_PATH}/${NS_HOST}.sh /usr/local/bin/${NS_HOST}
	
	if [ -L /usr/local/bin/${NS_HOST}_root ] ; then
                rm -f /usr/local/bin/${NS_HOST}_root
				rm -f /usr/local/bin/${NS_HOST}_root_ssh 2>/dev/null
        else
		if [ -e /usr/local/bin/${NS_HOST}_root ] ; then
	                echo "Hum! strange /usr/local/bin/${NS_HOST}_root is not a link ... whaooh! error error ... "
        	        exit 1
		fi
    fi
    ln -s ${APKG_PATH}/bin/root_nsenter.sh /usr/local/bin/${NS_HOST}_root
	ln -s ${APKG_PATH}/bin/root_nsenter.sh /usr/local/bin/${NS_HOST}_root_ssh
	
	if [ -L /usr/local/bin/${NS_HOST}_user ] ; then
                rm -f /usr/local/bin/${NS_HOST}_user
				rm -f /usr/local/bin/${NS_HOST}_user_ssh 2>/dev/null
        else
		if [ -e /usr/local/bin/${NS_HOST}_user ] ; then
	                echo "Hum! strange /usr/local/bin/${NS_HOST}_user is not a link ... whaooh! error error ... "
        	        exit 1
		fi
    fi
    ln -s ${APKG_PATH}/bin/user_nsenter.sh /usr/local/bin/${NS_HOST}_user
	ln -s ${APKG_PATH}/bin/user_nsenter.sh /usr/local/bin/${NS_HOST}_user_ssh
	
	if [ -L /usr/local/bin/${NS_HOST}_apkg ] ; then
                rm -f /usr/local/bin/${NS_HOST}_apkg
        else
		if [ -e /usr/local/bin/${NS_HOST}_apkg ] ; then
	                echo "Hum! strange /usr/local/bin/${NS_HOST}_user is not a link ... whaooh! error error ... "
        	        exit 1
		fi
    fi
    # ln -s ${APKG_PATH}/bin/apkg_mngt.sh /usr/local/bin/${NS_HOST}_apkg
	
	
	if [ -L /usr/local/bin/mksquashfs ] ; then
        rm -f /usr/local/bin/mksquashfs
		ln -s ${APKG_PATH}/bin/mksquashfs /usr/local/bin/mksquashfs
    else
		if [ -e /usr/local/bin/mksquashfs ] ; then
	       echo "Hum! strange /usr/local/bin/mksquashfs is not a link ... whaooh! error or new Asustor delivery ... " 
		else
			ln -s ${APKG_PATH}/bin/mksquashfs /usr/local/bin/mksquashfs
		fi
    fi
	
    if [ -L /usr/local/bin/unsquashfs ] ; then
        rm -f /usr/local/bin/unsquashfs
		ln -s ${APKG_PATH}/bin/unsquashfs /usr/local/bin/unsquashfs
    else
		if [ -e /usr/local/bin/unsquashfs ] ; then
	       echo "Hum! strange /usr/local/bin/unsquashfs is not a link ... whaooh! error or new Asustor delivery ... " 
		else
			ln -s ${APKG_PATH}/bin/unsquashfs /usr/local/bin/unsquashfs
		fi
    fi
	
	if [ -L /usr/local/bin/tmux ] ; then
        rm -f /usr/local/bin/tmux
		ln -s ${APKG_PATH}/bin/tmux /usr/local/bin/tmux
    else
		if [ -e /usr/local/bin/tmux ] ; then
	       echo "Hum! strange /usr/local/bin/tmux is not a link ... whaooh! error or new Asustor delivery ... " 
		else
			ln -s ${APKG_PATH}/bin/tmux /usr/local/bin/tmux
		fi
    fi
}

load_modules(){
	KVER=$(/bin/uname -r)
	if [ ! -e /lib/modules/${KVER}/modules.dep ] ; then
		if [ -e /lib/modules/${KVER}/modules.dep.bb ] ; then
			PWD=${pwd}
			cd /lib/modules/${KVER}/
			ln -s modules.dep.bb modules.dep
			cd ${PWD}
		fi
	fi
	if [ -e ${APKG_PATH}/modules/${KVER}/${NS_HOST}.list ] ; then
		while read MOD
		do
			if [ -z "${MOD}" ] ; then
				continue
				### ignore empty line
			else
				if [ -e /lib/modules/${KVER}/${MOD}.ko ] ; then
					/sbin/modprobe ${MOD}
					echo "Load module $MOD using modprobe for $KVER"
				else
					if [ -e ${APKG_PATH}/modules/${KVER}/${MOD}.ko ] ; then
						insmod ${APKG_PATH}/modules/${KVER}/${MOD}.ko
						echo "Load module $MOD using lsmod for $KVER"
					fi
				fi
			fi
		done < ${APKG_PATH}/modules/${KVER}/${NS_HOST}.list
	else
		echo "No modules to load"
	fi
}

test_apkg_enable(){
	### TEST if apkg is Enable
	APKG_ENABLE=$(/usr/sbin/apkg --info-installed ${NS_HOST} | grep 'Enabled:' | awk '{print $2}')
	if [ "$APKG_ENABLE" != "Yes" ] ; then
		echo "Hum! the APKG is disabled ..."
		exit 1
	fi
#		echo "Hum! ${NS_HOST} is NOT Enable"
#		exit 1
#	fi
}

test_aswm_running(){
	ps -eaf | grep -v grep | grep -q aswm
	if [ $? -ne 0 ] ; then
		echo "Hum! Asportal is not started yet ????? strange ${NS_HOST} can't start ... "
		/usr/sbin/applog --level 1 --package "${NS_HOST}" --event "Hum! Asportal is not started yet ????? strange ${NS_HOST} or action in can't start ... "
		exit 1
	fi
}

start_autorun(){
	if [ "$AUTOR" != "XXX" ] ; then
		ps -eaf | grep -q ${AUTOR}.sh
		if [ $? -ne 0 ] ; then
			/usr/local/AppCentral/${AUTOR}/run_${AUTOR}.sh &
		fi
	else
		# internal autorun
		AUTOR=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} MYHD_AUTORUN)
		if [ "$AUTOR" != "NONE" ] ; then
			/usr/local/AppCentral/${AUTOR}/run_${AUTOR}.sh &
		fi
	fi
}

get_my_autorun(){
	echo "====="
	echo "${NS_HOST} autorun is set to start : "
	/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} MYHD_AUTORUN
	echo "====="
}

set_my_autorun(){
	if [ -z "${MYAUTO}" ] ; then
		usage
		exit 1
	fi
	apkg --list | grep -q ^${MYAUTO}
	if [ $? -eq 0 ] ; then
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} MYHD_AUTORUN ${MYAUTO}
		exit 0
	else
		if [ "${MYAUTO}" != "NONE" ] ; then
			echo "autorun : ${MYAUTO} required don't exist"
			echo "NOTHING done"
			list_MH_app_for_auto
			exit 1
		else
			/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} MYHD_AUTORUN ${MYAUTO}
			exit 0
		fi
	fi
}

list_MH_app(){
	/usr/sbin/apkg --list | grep ^MH | tr -s " " ":" > /tmp/${NS_HOST}_installed
	# echo "==== get the file in ${NS_HOST} repository in Father_Mande Web site"
	echo -e "==== ${BLUE} LIST installed MH/MH16/MH18 companion applications installed AND APKG version ${NC}"
	/usr/bin/wget -q -O ${APKG_PATH}/${NS_HOST}_Apps_list https://www.father-mande.ovh/A/F/${NS_HOST}_Apps_list 
	if [ $? -eq 0 ] ; then
		while read line
		do
			A_NAME="$(echo $line | cut -f 1 -d ':')"
			grep -q ^${A_NAME} /tmp/${NS_HOST}_installed
			if [ $? -eq 0 ] ; then
				V_NAME="$(echo $line | cut -f 2 -d ':')"
				COMMENT="$(echo $line | cut -f 4 -d ':')"
				UBU_REPO_NAME_EXEC=""
				UBU_REPO_NAME_EXEC="$(echo $line | cut -f 5 -d ':')"
				I_VNAME=$(grep "^${A_NAME}:" /tmp/${NS_HOST}_installed | cut -f 3 -d ":")
				if [ "${V_NAME}" = "${I_VNAME}" ] ; then
					echo -e "${BOLD}APKG${UNBOLD} : ${BLUE}${BOLD}${A_NAME}${UNBOLD}${NC}   Version : ${BLUE}${V_NAME}${NC} Installed ${BLUE}with SAME${NC} Web Store Version"
				else
					echo -e "${BOLD}APKG${UNBOLD} : ${BLUE}${BOLD}${A_NAME}${UNBOLD}${NC}   Version : ${BLUE}${V_NAME}${NC} Installed ${RED}BUT Version DIFFER${NC} with Web Store : ${RED}${I_VNAME}${NC}"
				fi
				if [ ! -z "${UBU_REPO_NAME_EXEC}" ] ; then
					ps -eaf | grep jchroot | grep -q ${NS_HOST}
					if [ $? -eq 0 ] ; then
						### try to get Ubuntu version
						DPKG_VER=$(/usr/local/bin/${NS_HOST}_root "/usr/bin/dpkg -l ${UBU_REPO_NAME_EXEC} 2>/dev/null | grep ^ii | tr -s ' ' | cut -f 3 -d ' ' ")
						if [ ! -z ${DPKG_VER} ] ; then
							echo -e " ........... ${BOLD}UBUNTU Package${UNBOLD} Version is : ${BLUE}${BOLD}${DPKG_VER}${UNBOLD}${NC} "
						fi
					fi
				fi
				echo ""
			fi
		done < ${APKG_PATH}/${NS_HOST}_Apps_list
	else
		#/usr/sbin/apkg --list | grep ^MH | sed "s/ - / Ver. /"
		for A in $(/usr/sbin/apkg --list | grep ^MH | sed "s/ - / : /" | tr -d " ")
		do
			A_NAME=$(echo "$A" |cut -f 1 -d ":")
			V_NAME=$(echo "$A" |cut -f 2 -d ":")
			echo -e " APKG : ${BLUE}${BOLD}${A_NAME}${UNBOLD}${NC} APKG Version : ${BLUE}${V_NAME}${NC}"
		done
	fi
	echo "==== End of list"
}

list_MH_app_for_auto(){
	echo "==== LIST installed MH/MH16/MH18 companion applications installed available for Autorun"
	/usr/sbin/apkg --list | grep ^MH | cut -f 1,2 -d "-"
	echo "==== End of list"
}

get_App_available(){
	rm -f /tmp/${NS_HOST}_Apps_instalable
	/usr/sbin/apkg --list | grep ^MH | tr -s " " ":" > /tmp/${NS_HOST}_installed
	# echo "==== get the file in ${NS_HOST} repository in Father_Mande Web site"
	/usr/bin/wget -q -O ${APKG_PATH}/${NS_HOST}_Apps_list https://www.father-mande.ovh/A/F/${NS_HOST}_Apps_list 
	if [ $? -eq 0 ] ; then
		echo -e "==== list of ${NS_HOST} companion applications available for installation in Ubuntu ${BLUE}${UVER}${NC}"
		echo ""
		while read line
		do
			VALID="NO"
			A_NAME="$(echo $line | cut -f 1 -d ':')"
			V_NAME="$(echo $line | cut -f 2 -d ':')"
			MIN_VER="$(echo $line | cut -f 3 -d ':')"
			if [ -z "$MIN_VER" ] ; then
				MIN_VER="Unknown"
			fi
			COMMENT="$(echo $line | cut -f 4 -d ':')"
			### any value for UBU_REPO_NAME_EXEC (Internal name of package (dpkg) or  EMPTY = Not an Ubuntu package )
			UBU_REPO_NAME_EXEC=""
			UBU_REPO_NAME_EXEC="$(echo $line | cut -f 5 -d ':')"		
			### test if A_NAME is coherent with UVER
			case ${A_NAME} in
				MH-*)
					VALID="YES"
					;;
				MH16-*)
					if [ "$UVER" = "1604" ] ; then
						VALID="YES"
					fi
					;;
				MH18-*)
					if [ "$UVER" = "1804" ] ; then
						VALID="YES"
					fi
					;;
				*)
					:
					;;
			esac 
			if [ "${VALID}" = "YES" ] ; then
				grep -q "^${A_NAME}:" /tmp/${NS_HOST}_installed
				if [ $? -eq 0 ] ; then
					I_ANAME=$(grep "^${A_NAME}:" /tmp/${NS_HOST}_installed | cut -f 1 -d ":")
					I_VNAME=$(grep "^${A_NAME}:" /tmp/${NS_HOST}_installed | cut -f 3 -d ":")
					if [ "${V_NAME}" = "${I_VNAME}" ] ; then
						echo -e "${BOLD}APKG${UNBOLD} : ${BLUE}${BOLD}${A_NAME}${UNBOLD}${NC}   Version : ${BLUE}${V_NAME}${NC} Installed ${BLUE}with SAME${NC} Version"
					else
						echo -e "${BOLD}APKG${UNBOLD} : ${BLUE}${BOLD}${A_NAME}${UNBOLD}${NC}   Version : ${BLUE}${V_NAME}${NC} Installed ${RED}BUT Version DIFFER${NC} : ${RED}${I_VNAME}${NC}"
					fi
					if [ ! -z "$UBU_REPO_NAME_EXEC" ] ; then
						ps -eaf | grep jchroot | grep -q ${NS_HOST}
						if [ $? -eq 0 ] ; then
							### try to get Ubuntu version
							DPKG_VER=$(/usr/local/bin/${NS_HOST}_root "/usr/bin/dpkg -l ${UBU_REPO_NAME_EXEC} 2>/dev/null | grep ^ii | tr -s ' ' | cut -f 3 -d ' ' ")
							if [ ! -z ${DPKG_VER} ] ; then
								echo -e " ........... ${BOLD}UBUNTU Package${UNBOLD} Version is : ${BLUE}${BOLD}${DPKG_VER}${UNBOLD}${NC} "
							fi
						fi
					fi
				else
					echo -e "APKG : ${BLUE}${BOLD}${A_NAME}${UNBOLD}${NC}   Version : ${BLUE}${V_NAME}${NC} is ${RED}NOT installed${NC}"
				fi
				echo -e "======= for ${NS_HOST} >= ${BLUE}${MIN_VER}${NC} Actual : ${BLUE}$(apkg --info-installed ${NS_HOST} | grep ^Version | tr -d ' ' | cut -f 2 -d ':')${NC} Comment : ${BLUE}${COMMENT}${NC}"
				echo ""
				echo "$line" >> /tmp/${NS_HOST}_Apps_instalable
			fi
			#echo -e "${BLUE}${NC}"
		done < ${APKG_PATH}/${NS_HOST}_Apps_list
	else
		echo "Hum! problem to download the repository list"
		exit 1
	fi
}

install_App_from_store(){
	echo "Do some verification"
	if [ ! -e ${APKG_PATH}/${NS_HOST}_Apps_list ] ; then
		echo "Please refresh list from App. Store using : $0 get_App_available"
		exit 1
	fi
	grep -q "^${APKG_NAME}:${VERSION}" ${APKG_PATH}/${NS_HOST}_Apps_list
	if [ $? -ne 0 ] ; then
		echo "Hum! seem that ${APKG_NAME} is not in the App. Store or VERSION is incorrect ... verify and refresh using : $0 get_App_available"
		exit 1
	fi
	# require two argument : APKG_NAME and VERSION
	# try getting the apk
	echo "Download from Web store the APK"
	/usr/bin/wget -q -O /share/Public/${APKG_NAME}_${VERSION}_x86-64.apk https://www.father-mande.ovh/A/apkg/${APKG_NAME}_${VERSION}_x86-64.apk
	if [ $? -eq 0 ] ; then
		if [ -e /share/Public/${APKG_NAME}_${VERSION}_x86-64.apk ] ; then
			/usr/sbin/apkg --list | grep -q "^${APKG_NAME}" 
			if [ $? -eq 0 ] ; then
				echo "Update require"
				/usr/sbin/apkg --disable ${APKG_NAME}
				sleep 2
				/usr/sbin/apkg --remove ${APKG_NAME}
				sleep 2
				NB=60
				while [ $NB -gt 0 ]
				do
					/usr/sbin/apkg --list | grep -q "^${APKG_NAME}"
					if [ $? -eq 0 ] ; then
						### still exist wait max 2 minutes
						sleep 2
						NB=$((NB-1))
					else
						### deleted as well 
						break
					fi
				done
			fi
			echo "Now install ${APKG_NAME}_${VERSION}_x86-64.apk"
			/usr/sbin/apkg --install /share/Public/${APKG_NAME}_${VERSION}_x86-64.apk
		else
			echo "Hum! /share/Public/${APKG_NAME}_${VER}_x86-64.apk don't exist ???? please check"
			exit 1
		fi
	else
		echo "error downloading ${APKG_NAME}_${VERSION}_x86-64.apk ... confirm APKG_NAME and VERSION"
		exit 1
	fi	
}

remove_application(){
	echo "remove ${APKG_NAME}"
	/usr/sbin/apkg --list | grep -q "^${APKG_NAME}" 
	if [ $? -eq 0 ] ; then
		/usr/sbin/apkg --disable ${APKG_NAME}
		sleep 2
		/usr/sbin/apkg --remove ${APKG_NAME}
		sleep 2
		NB=60
		while [ $NB -gt 0 ]
		do
			/usr/sbin/apkg --list | grep -q "^${APKG_NAME}"
			if [ $? -eq 0 ] ; then
				### still exist wait max 2 minutes
				sleep 2
				NB=$((NB-1))
			else
				### deleted as well 
				break
			fi
		done
	else
		echo "${APKG_NAME} can't be removed (not exist ?)"
	fi
}

initial_tasks(){
	### Initial clean_up
	rm -f $APKG_PATH/${NS_HOST}.out
	rm -f /tmp/${NS_HOST}.pid
	if [ ! -e /var/run/utmp ] ; then
		touch /var/run/utmp
	fi
	if [ -e ${APKG_PATH}/fstab_temp ] ; then
		rm -f ${APKG_PATH}/fstab_temp
	fi
	touch ${APKG_PATH}/fstab_temp
	if [ ! -e ${APKG_PATH}/fstab_include ] ; then
		touch ${APKG_PATH}/fstab_include
	fi
	if [ ! -e /share/Public/${NS_HOST}_package ] ; then
		mkdir -p /share/Public/${NS_HOST}_package
		chmod 777 /share/Public/${NS_HOST}_package
	fi
	#### here the ssh key generation and the .asoundrc
	manage_adm_infos_keys
	### test if astr user exist 
	grep -q "^astr:" /etc/passwd
	if [ $? -eq 0 ] ; then
		grep "^astr:" /etc/passwd | grep -q "${NS_HOST} user"
		if [ $? -eq 0 ] ; then
			###OK it's my astr user
			echo "${NS_HOST} astr user exist ..."
		else
			echo "Hum! strange PLEASE VERIFY"
		fi
	else
		echo "create ${NS_HOST} astr user"
		# /bin/adduser -u 59999 -G administrators -g "${NS_HOST} user" -h /share/homes/astr -p astrfr1 astr
		$(which useradd) -u 59999 -G root -g administrators -c "${NS_HOST} user" -d /home/astr -p "$(/usr/bin/mkpasswd astr1 -S xypatdf -m opensll)" astr
		if [ ! -e /home/astr ] ; then
			/bin/mkdir /home/astr
			/bin/chown astr:administrators /home/astr
		fi
		/bin/addgroup astr users
	fi
	if [ -e ${APKG_FOLDER}/.${NS_HOST}/ ] ; then
		cp -p ${APKG_PATH}/bin/uninstall_environment.sh ${APKG_FOLDER}/.${NS_HOST}/
		cp -p ${APKG_PATH}/bin/uninstall_apkg.sh ${APKG_FOLDER}/.${NS_HOST}/
	fi
	### add usdiers for WebUI
	if [ ! -e /etc/sudoers.d/001_${NS_HOST} ] ; then
		ln -s ${APKG_PATH}/bin/001_${NS_HOST} /etc/sudoers.d/
	fi
	if [ ! -e /MHD/lib ] ; then
		mkdir -p /MHD/lib
		cp -pP ${APKG_PATH}/mylib/* /MHD/lib/
	fi
	### last in case of user requirement
	if [ -e ${APKG_PATH}/pre_load.sh ] ; then
		${APKG_PATH}/pre_load.sh
	fi
}

exit_jchroot_on_error(){
	if [ ! -e /tmp/${NS_HOST}.pid ] ; then
		echo "Hum! seem not started ... "
		/usr/sbin/applog --level 2 --package "${NS_HOST}" --event "${NS_HOST} was NOT started ... consult log in /tmp "
		if [ -e $APKG_PATH/${NS_HOST}.out ] ; then
			echo "======="
			cat $APKG_PATH/${NS_HOST}.out
			echo "======="
		fi
		exit 1
	fi
}

update_packages(){
	if [ -e /tmp/${NS_HOST}.pid ] ; then
		rm -f ${CHROOT_PATH}/.reboot_if_require_by_update ${CHROOT_PATH}/.noreboot_require
		if [ "$CHRT" = "jchroot" ] ; then
			${MYHD_BIN}/tmux send-keys -t ${NS_HOST} "/${NS_HOST}_scripts/bin/update_ubuntu_package.sh" Enter
		else
			/usr/local/bin/${NS_HOST}_root "/${NS_HOST}_scripts/bin/update_ubuntu_package.sh" 
		fi
		### here wait for result during long time
		sleep 2
		RESTART="NO"
		NBCL=150
		while [ $NBCL -gt 0 ]
		do
			if [ -e ${CHROOT_PATH}/.reboot_if_require_by_update ] ; then
				RESTART="YES"
				rm -f ${CHROOT_PATH}/.reboot_if_require_by_update
				break
			fi
			if [ -e ${CHROOT_PATH}/.noreboot_require ] ; then
				rm -f ${CHROOT_PATH}/.noreboot_require
				break
			fi
			sleep 2
			NBCL=$((NBCL-1))
		done 
		RESTART_IF_UPD_REQUIRE=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} RESTART_IF_UPD_REQUIRE)
		if [ "$RESTART_IF_UPD_REQUIRE" = "TRUE" ] ; then
			if [ "$RESTART" = "YES" ] ; then
				$0 restart
			fi
		fi
		
    else
        echo "${NS_HOST} don't run ??? so nothing to do ... "
        exit 1
    fi
}

clean_for_backup(){
	if [ -e /tmp/${NS_HOST}.pid ] ; then
		/usr/local/bin/${NS_HOST}_root "/usr/bin/apt-get -y clean"
		if [ "$FULL" = "full" ] ; then
			/usr/local/bin/${NS_HOST}_root "/usr/bin/apt-get -y autoclean"
		fi
		/usr/local/bin/${NS_HOST}_root "/bin/rm -rf /usr/share/man/*"
		/usr/local/bin/${NS_HOST}_root "/bin/rm -rf /usr/share/doc/*"
	else
		echo "clean_for_backup require ${NS_HOST} BE UP (started)"
	fi
}

myhd_download_env(){
echo "Download Ubuntu if not yet available"
INSTALLED=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} INSTALLED)
if [ "$INSTALLED" = "FALSE" ] ; then
	echo "Ubuntu Not installed ... download and install"
	echo "THEN ${NS_HOST} WILL BE RESTARTED AUTOMATICALLY "
	REP=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} DOWNLOAD_RUNNING)
	if [ "$REP" = "FALSE" ] ; then	
		FULL=""
		if [ -e /share/Public/.${NS_HOST}_chroot_full ] ; then
			FULL="full"
		fi
		### test if not running ...
		ps -eaf | grep -v grep | grep -q download_${NS_HOST}.sh
		if [ $? -eq 0 ] ; then
			echo "Download is running "
			exit 0
		else 
			/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} DOWNLOAD_RUNNING TRUE
			${MYHD_BIN}/nohup ${MYHD_BIN}/download_${NS_HOST}.sh ${UVER} $FULL >/tmp/download_${NS_HOST}.log 2>&1 &
			sleep 1
			exit 0
		fi
	else
		echo "Please wait up to download of Ubuntu environment will be done"
		exit 1
	fi
fi 
}

get_if_autorun(){
	if [ -e /usr/local/AppCentral/asportal/etc/app_conf/startup ] ; then
		grep -q "^MH-" /usr/local/AppCentral/asportal/etc/app_conf/startup
		if [ $? -eq 0 ] ; then
			AUTOR=$(head -n 1 /usr/local/AppCentral/asportal/etc/app_conf/startup)
			/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} MYHD_AUTORUN ${AUTOR}
			AUTOR="XXX"
		else
			AUTOR="XXX"
		fi
	fi
} 

mount_require_for_chroot(){
	echo "chroot mount shared folder"
	while read LINE
	do
		FOLDER_MNT="$(echo $LINE | cut -f 1 -d " ")"
		PATH1="${FOLDER_MNT}"
		if [ "${PATH1:$((${#PATH1}-1)):1}" = "/" ] ; then
			P1="${PATH1%?}"
		else
			P1="${PATH1}"
		fi
		MNT_POINT="${CHROOT_PATH}/$(echo $LINE | cut -f 2 -d " ")"
		PATH1="${MNT_POINT}"
		if [ "${PATH1:$((${#PATH1}-1)):1}" = "/" ] ; then
			P2="${PATH1%?}"
		else
			P2="${PATH1}"
		fi
		echo "/bin/mount -o rbind ${P1} ${P2}"
		/bin/mount -o rbind ${P1} ${P2}
	done < $APKG_PATH/fstab_${NS_HOST}
}

install_xbindkeys(){
	if [ $(/usr/local/bin/${NS_HOST}_root "/usr/bin/dpkg -l xbindkeys | /bin/grep ^ii | /bin/grep -q xbindkeys ; echo \$?") -eq 0 ] ; then
		echo "xbindkeys already installed"
	else
		echo "install xbindkeys now"
		/usr/local/bin/${NS_HOST}_root "/usr/bin/apt-get -y install xbindkeys"
	fi
	### next lines reported up to generic solution now it's by application
	#if [ ! -e ${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_scripts/files/.xbindkeysrc ] ; then
	#	cp ${APKG_PATH}/files/.xbindkeysrc ${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_scripts/files/.xbindkeysrc
	#	chmod a+r ${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_scripts/files/.xbindkeysrc
	#fi
	#echo "use <CRTL><SHIFT>x to kill program without exit button on exit menu"
	#echo "debug is in ${NS_HOST} inside : /tmp/xbindkeys.log "
	#/usr/local/bin/${NS_HOST}_root "rm -f /tmp/xbindkeys.log"
}

post_start(){
	### to do in Asportal
	### update ssh keys 
	cat /usr/etc/ssh/ssh_host_rsa_key.pub > ${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_scripts/files/authorized_keys
	chmod a+r ${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_scripts/files/authorized_keys
	copy_adm_authorized_keys
	### update ADM root keys for sshfs from ${NS_HOST}
	copy_chroot_authorized_keys
	### to do in ${NS_HOST} 
	start_myserv_by_user
	init_alsa_audio
	###ONLY case don't works if asportal is not up
	
	# enable_change_ir_management
	if [ -e ${APKG_PATH}/post_load.sh ] ; then
		${APKG_PATH}/post_load.sh
	fi
	if [ "$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} UPDATE_AT_BOOT)" = "TRUE" ] ; then
		echo "We update packages in background ... so if a PKG lock is returned in Ubuntu ... just wait"
		update_packages
	fi
	install_xbindkeys
	start_autorun
}

start_jchroot(){
	${MYHD_BIN}/tmux has-session -t ${NS_HOST} 2>/dev/null
	if [ $? -eq 0 ] ; then
		${MYHD_BIN}/tmux kill-session -t ${NS_HOST}
	fi
	${MYHD_BIN}/tmux new-session -d -s ${NS_HOST}
	${MYHD_BIN}/tmux send-keys -t ${NS_HOST} "${APKG_PATH}/xbin/jchroot  -p /tmp/${NS_HOST}.pid -f $APKG_PATH/fstab_${NS_HOST} ${CHROOT_PATH} -- /bin/bash " Enter
	## ${MYHD_BIN}/tmux send-keys -t ${NS_HOST} "${APKG_PATH}/xbin/jchroot  -p /tmp/${NS_HOST}.pid -u 0 -g 0 -f $APKG_PATH/fstab_${NS_HOST} ${CHROOT_PATH} -- /bin/bash " Enter
	sleep 2
	${MYHD_BIN}/tmux send-keys -t ${NS_HOST} "/${NS_HOST}_scripts/bin/rcS" Enter
	sleep 4
	### set access rigth for non root user"
	${MYHD_BIN}/tmux send-keys -t ${NS_HOST} "/${NS_HOST}_scripts/bin/rc.local start" Enter
	sleep 1
	exit_jchroot_on_error
	
	/usr/sbin/applog --level 0 --package "${NS_HOST}" --event  "${NS_HOST} was started ... "
	echo "now start in background a survey to manage a clean exit"
	${MYHD_BIN}/nohup ${APKG_PATH}/bin/wait_for_clean.sh ${NS_HOST} >/dev/null 2>&1 &
	### here we have to wait for end of initial part of the boot
	NB=20
	while [ $NB -gt 0 ]
	do
		ps -eaf | grep -v grep | grep -q /usr/sbin/dropbear
		if [ $? -eq 0 ] ; then
			echo "time to do extra works in ${NS_HOST}"
			break
		else
			sleep 3
			NB=$(($NB-1))
		fi
	done
	if [ $NB -le 0 ] ; then
		echo "==== PROBLEM : dropbear is not started after 1 minutes"
		echo "==== DO NOTHING more"
		/usr/sbin/applog --level 2 --package "${NS_HOST}" --event "dropbear in ${NS_HOST} was NOT started NOTHING more will be do ... (after waiting 1 minutes) please investigate"
	else
		post_start
	fi
}

prepare_jinit(){
	## remove getty to avoid shutdown problem 
	echo "remove (if needed) getty.target from multi-user.target.wants"
	if [ -e ${CHROOT_PATH}/lib/systemd/system/multi-user.target.wants/getty.target ] ; then
		rm -f ${CHROOT_PATH}/lib/systemd/system/multi-user.target.wants/getty.target
	fi
	## if /run/shm is a link to /dev/shm ... systemd crash
	if [ ! -d ${CHROOT_PATH}/run/shm ] ; then
		rm -f ${CHROOT_PATH}/run/shm
		mkdir ${CHROOT_PATH}/run/shm
		chmod 1777 ${CHROOT_PATH}/run/shm
	fi
	## add rc.local / dropbear need to run as well
	echo "add (if needed) rc.local service to systemd"
	cp -p ${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_scripts/bin/rc.local ${CHROOT_PATH}/etc/
	#if [ ! -e ${CHROOT_PATH}/etc/systemd/system/rc-local.service ] ; then
	#	cp -p ${APKG_PATH}/files/rc-local.service ${CHROOT_PATH}/etc/systemd/system/
	#	cp -p ${APKG_PATH}/files/rc-local.service ${CHROOT_PATH}/lib/systemd/system/
	#	PWD="$(pwd)"
	#	# create link ${CHROOT_PATH}/lib/systemd/system/multi-user.target.wants/rc-local.service
	#	cd ${CHROOT_PATH}/etc/systemd/system/multi-user.target.wants
	#	ln -s ../rc-local.service
	#	cd ${CHROOT_PATH}/lib/systemd/system/multi-user.target.wants
	#	ln -s ../rc-local.service
	#	cd "${PWD}"
	#fi
	echo "add (if needed) dropbear service to systemd"
	if [ ! -e ${CHROOT_PATH}/etc/systemd/system/dropbear.service ] ; then
		cp -p ${APKG_PATH}/files/dropbear.service ${CHROOT_PATH}/etc/systemd/system/
		cp -p ${APKG_PATH}/files/dropbear.service ${CHROOT_PATH}/lib/systemd/system/
		PWD="$(pwd)"
		# create link ${CHROOT_PATH}/lib/systemd/system/multi-user.target.wants/rc-local.service
		cd ${CHROOT_PATH}/etc/systemd/system/multi-user.target.wants
		ln -s ../dropbear.service
		#cd ${CHROOT_PATH}/lib/systemd/system/multi-user.target.wants
		#ln -s ../dropbear.service
		cd "${PWD}"
	fi
}

start_jinit(){
	prepare_jinit
	${MYHD_BIN}/nohup ${APKG_PATH}/xbin/jchroot  -p /tmp/${NS_HOST}.pid -f $APKG_PATH/fstab_${NS_HOST} ${CHROOT_PATH} -- /sbin/init >/tmp/jchroot.out 2>&1 &
	# ${MYHD_BIN}/nohup ${APKG_PATH}/xbin/jchroot  -p /tmp/${NS_HOST}.pid -u 0 -g 0 -f $APKG_PATH/fstab_${NS_HOST} ${CHROOT_PATH} -- /sbin/init >/tmp/jchroot.out 2>&1 &
	sleep 10
	exit_jchroot_on_error
	/usr/sbin/applog --level 0 --package "${NS_HOST}" --event  "${NS_HOST} was started ... "
	echo "now start in background a survey to manage a clean exit"
	${MYHD_BIN}/nohup ${APKG_PATH}/bin/wait_for_clean.sh ${NS_HOST} >/dev/null 2>&1 &
	NB=20
	while [ $NB -gt 0 ]
	do
		ps -eaf | grep -v grep | grep -q /lib/systemd/systemd-logind
		if [ $? -eq 0 ] ; then
			echo "time to do extra works in ${NS_HOST}"
			sleep 2
			## try starting via systemd dropbear
			/usr/local/bin/${NS_HOST}_root "/bin/systemctl start dropbear"
			break
		else
			sleep 3
			NB=$(($NB-1))
		fi
	done
	if [ $NB -le 0 ] ; then
		echo "==== PROBLEM : /lib/systemd/systemd-logind is not started after 1 minutes"
		echo "==== DO NOTHING more"
		/usr/sbin/applog --level 2 --package "${NS_HOST}" --event "/lib/systemd/systemd-logind in ${NS_HOST} was NOT started NOTHING more will be do ... (after waiting 1 minutes) please investigate"
	else
		post_start
	fi
}

stop_jchroot(){
	if [ -e /tmp/${NS_HOST}.pid ] ; then
		#/usr/local/bin/${NS_HOST}_root "/sbin/shutdown -h now ; exit"
		echo "Stop services in the Ubuntu environment of ${NS_HOST}"
		${MYHD_BIN}/tmux send-keys -t ${NS_HOST} "/${NS_HOST}_scripts/bin/rcK" Enter
		## first exit to stop jchroot
		echo "Now stop the chroot manager in ${NS_HOST}"
		${MYHD_BIN}/tmux send-keys -t ${NS_HOST} "builtin exit" Enter
		sleep 5
		echo "Clean last element of ${NS_HOST}"
		## second to quit tmux itself and close session
		${MYHD_BIN}/tmux send-keys -t ${NS_HOST} "exit" Enter
		NB=30
		echo "Now we have to wait for cleaning shell, that clean all potential residual things"
		while [ $NB -gt 0 ]
		do
			PID=$(pidof wait_for_clean.sh)
			if [ -z "$PID" ] ; then
				sleep 2
				break
			else
				sleep 4
				echo "Please wait ... shutdown is running"
			fi
			NB=$(($NB-1))
		done
		if [ $NB -eq 0 ] ; then
			/usr/sbin/applog --level 1 --package "${NS_HOST}" --event  "${NS_HOST} was NOT totally stopped ... AFTER 2 minutes I kill it"
			echo "Please investigate ${NS_HOST} was NOT totally stopped ... AFTER 2 minutes I kill it"
			kill -9 $(cat /tmp/${NS_HOST}.pid)
			exit 1
		else
			/usr/sbin/applog --level 0 --package "${NS_HOST}" --event "${NS_HOST} was stopped ... "
			echo "${NS_HOST} was stopped ... "
			# restore_swaps : MUST BE reactivated if systemd work again ...
		fi	
	else
		echo "${NS_HOST} don't run ??? so nothing to do ... "
		exit 1
	fi	
}

stop_jinit(){
	if [ -e /tmp/${NS_HOST}.pid ] ; then
		/usr/local/bin/${NS_HOST}_root "/sbin/shutdown -h now ; exit"
		NB=30
		echo "Now we have to wait for cleaning shell, that clean all potential residual things"
		while [ $NB -gt 0 ]
		do
			PID=$(pidof wait_for_clean.sh)
			if [ -z "$PID" ] ; then
				sleep 2
				break
			else
				sleep 4
				echo "Please wait ... shutdown is running"
			fi
			NB=$(($NB-1))
		done
		if [ $NB -eq 0 ] ; then
			/usr/sbin/applog --level 1 --package "${NS_HOST}" --event  "${NS_HOST} was NOT totally stopped ... AFTER 2 minutes I kill it"
			echo "Please investigate ${NS_HOST} was NOT totally stopped ... AFTER 2 minutes I kill it"
			kill -9 $(cat /tmp/${NS_HOST}.pid)
			exit 1
		else
			/usr/sbin/applog --level 0 --package "${NS_HOST}" --event "${NS_HOST} was stopped ... "
			echo "${NS_HOST} was stopped ... "
			restore_swaps
		fi
	else
		echo "${NS_HOST} don't run ??? so nothing to do ... "
		exit 1
	fi
}

if [ -e ${APKG_PATH}/.fresh_install ] ; then
	## don't test root it's admin just one time
	rm -f ${APKG_PATH}/.fresh_install
else
	if [ "${USER}" != "root" ] ; then
		echo "You MUST be root to execute ${NS_HOST} please log you as root/your_admin_password not admin or any user_name"
		exit 1
	fi
fi

if [ -e /share/Public/.${NS_HOST}_trace_run ] ; then
	set -x
	rm -f /share/Public/.${NS_HOST}_trace_run
fi
if [ ! -e /tmp/.${NS_HOST}_lock ] ; then
	echo "Run only after boot / reboot / update of ${NS_HOST}"
	
	if [ ! -e ${APKG_PATH}/${NS_HOST}.conf ] ; then
		mv ${APKG_PATH}/APKG.conf.delivery ${APKG_PATH}/${NS_HOST}.conf
	else
		grep -q ^LANG_WEBUI ${APKG_PATH}/${NS_HOST}.conf
		if [ $? -ne 0 ] ; then
			/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} LANG_WEBUI en
		fi
	fi
	if [ ! -e ${APKG_PATH}/${NS_HOST}_1604.conf ] ; then
		mv ${APKG_PATH}/UBUNTU_1604.conf.delivery ${APKG_PATH}/${NS_HOST}_1604.conf
	fi
	if [ ! -e ${APKG_PATH}/${NS_HOST}_1804.conf ] ; then
		mv ${APKG_PATH}/UBUNTU_1804.conf.delivery ${APKG_PATH}/${NS_HOST}_1804.conf
	fi
	#if [ ! -e ${APKG_PATH}/${NS_HOST}_App.conf ] ; then
	#	mv ${APKG_PATH}/${NS_HOST}_App.conf.delivery ${APKG_PATH}/${NS_HOST}_App.conf
	#fi
	#if [ -e ${APKG_PATH}/${NS_HOST}_apkg.tgz ] ; then
	#	PWD=$(pwd)
	#	cd ${APKG_PATH}
	#	tar xzf ${APKG_PATH}/${NS_HOST}_apkg.tgz
	#	rm -f ${APKG_PATH}/${NS_HOST}_apkg.tgz
	#	cd $PWD
	#fi
	load_modules
	link_to_exec
	save_swaps
	
	BACK_FOLDER=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} BACKUP_FOLDER)
	if [ -z "$BACK_FOLDER" ] ; then
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} BACKUP_FOLDER "${APKG_PATH}/${UVER}_snapshot"
	fi
	WEBUI=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} WEBUI)
	if [ -z "$WEBUI" ] ; then
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} WEBUI TRUE
	fi
	if [ ! -e /usr/builtin/etc/apache2/mods-available/authn_core.conf ] ; then
		echo "LoadModule authn_core_module /usr/builtin/lib/apache2/modules/mod_authn_core.so" > /usr/builtin/etc/apache2/mods-available/authn_core.conf
		PWD=$(pwd)
		cd /usr/builtin/etc/apache2/mods-enabled
		if [ ! -e authn_core.conf ] ; then
			ln -s ../mods-available/authn_core.conf
		fi
		/usr/builtin/etc/init.d/S54apache2 restart
		cd $PWD
	fi
	grep -q ^MYHD_AUTORUM ${APKG_PATH}/${NS_HOST}.conf
	if [ $? -ne 0 ] ; then
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} MYHD_AUTORUN NONE
	fi
	## get_ir_keytable
	if [ -e ${APKG_PATH}/run_once.sh ] ; then
		${APKG_PATH}/run_once.sh
		mv ${APKG_PATH}/run_once.sh ${APKG_PATH}/run_once.sh.executed
		## in case run_once will change it 
	fi
	CHRT=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} CHRT)
	if [ $? -ne 0 ] ; then
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} CHRT jchroot
		CHRT="jchroot"
	fi
	touch /tmp/.${NS_HOST}_lock
fi
UVER=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} QPKG_UBUNTU_VERSION)
if [ $? -ne 0 ] ; then
### case if update from previous version without QPKG_UBUNTU_VERSION value
	UVER=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} UVER)
	/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} QPKG_UBUNTU_VERSION ${UVER}
else
	/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} UVER ${UVER}
fi
CHROOT_PATH=${APKG_FOLDER}/.${NS_HOST}/${UVER}
CHRT=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} CHRT)

case "$1" in
start)
	echo "${NS_HOST} start ... requested"
	## redo it at each start in case of 
	initial_tasks
	## now download if need
	myhd_download_env
	###THINGS TODO AFTER download ... to avoid error when switching ...
	### update bin folder in ${NS_HOST}_scripts
	cp -p ${APKG_PATH}/scripts/bin/* ${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_scripts/bin/
	
	QPKG_FIRST_INSTALL=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} QPKG_FIRST_INSTALL)
	if [ "$QPKG_FIRST_INSTALL" = "TRUE" ] ; then
		## /usr/local/bin/${NS_HOST}_apkg install test
		/usr/sbin/apkg --install ${APKG_PATH}/files/MH-test_1.9.9_x86-64.apk
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} QPKG_FIRST_INSTALL FALSE
	fi
	
	# test_aswm_running
	test_apkg_enable
	### TEST if not already running
	ps -eaf | grep jchroot | grep -q ${NS_HOST}
	if [ $? -eq 0 ] ; then
		echo "Hum! ${NS_HOST} is already started "
		exit 1
	fi
	
	generate_fstab
	AUTOR="XXX"
	get_if_autorun
	echo "Now start jchroot in background"
	share_network	
	rm -f /tmp/${NS_HOST}.pid
	rm -f /tmp/jchroot.stop
	rm -f /tmp/jinit.stop
	if [ "${CHRT}" = "jchroot" ] ; then
		start_jchroot
	else
		start_jinit
	fi
;;
restart)
	$0 stop
	sleep 10
	### replace sleep by test if pid file is deleted
	$0 start
;;
stop)
	if [ "${CHRT}" = "jchroot" ] ; then
		if [ -e /tmp/jinit.stop ] ; then
			rm -f /tmp/jinit.stop
			stop_jinit
		else
			stop_jchroot
		fi
	else
		if [ -e /tmp/jchroot.stop ] ; then
			rm -f /tmp/jchroot.stop
			stop_jchroot
		else
			stop_jinit
		fi
	fi
;;
status)
	if [ ! -z "$2" ] ; then
		RED=${WRED}
		BLUE=${WBLUE}
		NC=${WNC}
		BOLD=${WBOLD}
		UNBOLD=${WUNBOLD}
	fi
	echo "==== is ${NS_HOST} running ?"
	ps -eaf | grep jchroot | grep -q ${NS_HOST}
        if [ $? -eq 0 ] ; then
                echo -e "==== ${RED} ${NS_HOST} is running ${NC}"
				echo -e "==== ${NS_HOST} Version ${BLUE} $(apkg --info-installed ${NS_HOST} | grep ^Version | tr -d " " | cut -f 2 -d ":") ${NC}"
				if [ "${CHRT}" = "jchroot" ] ; then
					echo -e "==== ${NS_HOST} start mode of isolated chroot is ${BLUE}BASH${NC}"
					${MYHD_BIN}/tmux send-keys -t ${NS_HOST} "ps -eaf > /${NS_HOST}_temp/ps.out" Enter
					sleep 1
					${MYHD_BIN}/tmux send-keys -t ${NS_HOST} "mount | grep share > /${NS_HOST}_temp/mount.out" Enter
				else
					echo -e "==== ${NS_HOST} start mode of isolated chroot is ${BLUE}SYSTEMD init${NC}"
					/usr/local/bin/${NS_HOST}_root "ps -eaf > /${NS_HOST}_temp/ps.out"
					/usr/local/bin/${NS_HOST}_root "mount | grep share > /${NS_HOST}_temp/mount.out"
				fi
				sleep 1
        else
			echo -e "==== ${RED} ${NS_HOST} is NOT running ${NC} "
			INSTALLED=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} INSTALLED)
			if [ "$INSTALLED" = "FALSE" ] ; then
				echo "${RED} ${NS_HOST} is not yet installed ... ${NC}"
				echo " DISPLAY LOG of Download then Install Ubuntu ... up to ==== END with FAILED or SUCCESS"
				while IFS= read -r line
				do
					PREF=$(echo "${line}" | cut -c 1-3)
					case ${PREF} in
						===)
							echo "${BLUE}${line}${NC}"
							;;
						+++)
							echo "${RED}${line}${NC}"
							;;
						*)
							echo "${line}"
					esac
				done < /tmp/download_${NS_HOST}.log
				#cat /tmp/download_${NS_HOST}.log
				echo ""
				echo "IN CASE OF FAILURE ... start AGAIN : ${NS_HOST} to restart download and install"
				echo "re-use status to display more LOG if not finished"
			fi
			echo "===="
			exit 0
        fi
	echo "===="
	echo -e  "==== Ubuntu Version in use : ${BLUE} ${UVER} ${NC}"
	echo "===="
	echo -e "==== PID is ${BLUE} $(cat /tmp/${NS_HOST}.pid) ${NC}"
	echo "===="
	echo -e "==== ${BLUE} List of tasks running in ${NS_HOST} ${NC}"
    echo "==== ==== PID are internal to ${NS_HOST} not as in A.D.M. "
	echo "==== ==== user name are internal to ${NS_HOST} not as in A.D.M. "
    cat  ${APKG_PATH}/${NS_HOST}_temp/ps.out
	echo "===="
	echo -e "==== ${BLUE} List of user know by ${NS_HOST} ${NC}"
	list_user
	echo "===="
	echo -e "==== ${BLUE} port used by ${NS_HOST} internal dropbear server ${NC}"
	echo "Internal Listen interface and port used : "
	echo "$(grep ^DROPBEAR_PORT ${CHROOT_PATH}/etc/default/dropbear)"
	echo "===="
	echo -e "==== ${BLUE} List shared ressources defined in ${NS_HOST} ${NC}"
	cat ${APKG_PATH}/${NS_HOST}_temp/mount.out
	echo "===="
	list_MH_app
	echo "===="
;;
list_available_app_for_autorun)
	list_MH_app_for_auto
;;
list_all_installed_apkg)
	if [ ! -z "$2" ] ; then
		RED=${WRED}
		BLUE=${WBLUE}
		NC=${WNC}
		BOLD=${WBOLD}
		UNBOLD=${WUNBOLD}
	fi
	list_MH_app
;;
list_my_autorun)
	get_my_autorun
;;
set_my_autorun)
	MYAUTO=${2}
	set_my_autorun
;;
get_App_available)
	## change for www access
	if [ ! -z "$2" ] ; then
		RED=${WRED}
		BLUE=${WBLUE}
		NC=${WNC}
		BOLD=${WBOLD}
		UNBOLD=${WUNBOLD}
	fi
	get_App_available
;;
install_App_from_store)
	if [ -z "${2}" ] ; then
		echo "Hum! you don't provide APKG_NAME as argument (MH-xxx; MH16-xxx or MH18-xxx)"
		exit 1
	else
		APKG_NAME=${2}
	fi
	if [ -z "${3}" ] ; then
		echo "Hum! you don't provide the version to install ??? check using : ${0} get_App_available"
		exit 1
	else
		VERSION=${3}
	fi
	install_App_from_store
;;
remove_application)
	if [ -z "${2}" ] ; then
		echo "Hum! you don't provide APKG_NAME as argument (MH-xxx; MH16-xxx or MH18-xxx)"
		exit 1
	fi
	remove_application
;;
set_use_jchroot)
	CHRT=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} CHRT)
	if [ "${CHRT}" = "jchroot" ] ; then
		echo "Nothing to do"
	else
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} CHRT jchroot
		echo "Please restart ${NS_HOST} to used jchroot bash in place of jchroot with systemd init "
		rm -f /tmp/.${NS_HOST}_lock
		touch /tmp/jinit.stop
	fi
;;
set_use_jinit)
	CHRT=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} CHRT)
	if [ "${CHRT}" = "jinit" ] ; then
		echo "Nothing to do"
	else
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} CHRT jinit
		echo "Please restart ${NS_HOST} to used jchroot with systemd init in place of jchroot bash"
		rm -f /tmp/.${NS_HOST}_lock
		touch /tmp/jchroot.stop
	fi
;;
enable_webui)
	/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} WEBUI TRUE
	echo "WebUI enabled"
;;
disable_webui)
	/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} WEBUI FALSE
	echo "WebUI disabled"
;;
set_webui_lang)
	if [ -z "$2" ] ; then
		echo "Please provide a language value : en, fr, etc."
		exit 1
	else
		if [ -e /share/Web/${NS_HOST}/text/$2 ] ; then
			/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} LANG_WEBUI $2
		else
			echo "HUM! seem that language folder $2 don't exist in /share/Web/${NS_HOST}/text ?"
			exit 1
		fi
	fi
;;
display_actual_webui_lang)
	echo "====="
	echo "Actual language for Webui is : $(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} LANG_WEBUI)"
	echo "====="
;;
list_available_lang_webui)
	echo "====="
	for F in /share/Web/${NS_HOST}/text/*
	do
		echo "$(basename $F)"
	done 
	echo "====="
;;
add_or_update_webui_user)
	if [ -z "$2" ] ; then
		echo "Please provide a user name to add or update"
		exit 1
	fi
	if [ -z "$2" ] ; then
		echo "Please provide a password for user $2"
		exit 1
	fi
	/usr/builtin/bin/htpasswd -b ${MYHD_BIN}/.htpassword ${2} ${3}
	echo "normally user $2 is added or updated with password you provide"
;;
list_webui_user)
	echo "====="
	cat ${MYHD_BIN}/.htpassword | cut -f 1 -d ":"
	echo "====="
;;
suppress_webui_user)
	NB=$(cat ${MYHD_BIN}/.htpassword | wc -l)
	if [ $NB -eq 1 ] ; then
		echo "only one user define ... NO delete possible"
		exit 1
	fi
	if [ -z "$2" ] ; then
		echo "Please provide a user name to delete"
		exit 1
	else
		grep -q ^${2} ${MYHD_BIN}/.htpassword
		if [ $? -eq 0 ] ; then
			sed -i "/^${2}/d" ${MYHD_BIN}/.htpassword
		else
			echo "$2 user name don't exist in password file"
			exit 1
		fi
	fi
;;
install_${NS_HOST}_package)
	# echo "Works in progress ... please wait next update "
	${MYHD_BIN}/install_package.sh "$2" "$3"
;;
uninstall_${NS_HOST})
	echo "THIS IS AN INTERACTIVE SHELL ... please answer"
	$0 stop
	sleep 2
	${MYHD_BIN}/uninstall_apkg.sh
	sleep 2
	${MYHD_BIN}/uninstall_environment.sh
	echo "Hum all normally is deleted at this point ..."
	echo "remove link to binary and system files"
	rm -f /usr/local/bin/${NS_HOST} /usr/local/bin/${NS_HOST}_apkg /usr/local/bin/${NS_HOST}_root /usr/local/bin/${NS_HOST}_user /etc/sudoers.d/001_${NS_HOST} /usr/local/bin/${NS_HOST}_root_ssh /usr/local/bin/${NS_HOST}_user_ssh
	echo "Now we request to Asustor to remove ${NS_HOST} APKG itself"
	/usr/sbin/apkg --remove ${NS_HOST}
;;
uninstall_all_${NS_HOST}_APKG)
	${MYHD_BIN}/uninstall_apkg.sh
	sleep 2
	echo "Hum all ${NS_HOST} QPKG are deleted at this point "
;;
uninstall_Ubuntu_environment)
	$0 stop
	sleep 2
	${MYHD_BIN}/uninstall_environment.sh
	echo "Hum Ubuntu environment normally is deleted at this point ..."
;;
switch_ubuntu_env)
	if [ -z "${2}" ] ; then
		echo "Hum! please provide parameters equal 1804 or 1604"
		exit 1
	else
		case "${2}" in
		1804)
			echo "You have choice to switch to Ubuntu 1804"
		;;
		1604)
			echo "You have choice to switch to Ubuntu 1604"
		;;
		*)
			echo "Hum only 1804 or 1604 are accepted as second argument"
			exit 1
		;;
		esac
	fi
	if [ ${UVER} = "${2}" ] ; then
		echo "Hum NOTHING to DO ... already using ${UVER}"
		exit 0
	fi
	$0 stop
	sleep 3
	/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} QPKG_UBUNTU_VERSION ${2}
	$0 start
;;
list_ubuntu_env)
	echo "Ubuntu version actually used : "
	echo " ${NS_HOST} Ubuntu : ${UVER}"
;;
change_adm_password)
	if [ -z "$2" ] ; then
		echo "Hum you must provide a user_name and a password"
		exit 1
	else
		grep -q "^${2}:" /etc/passwd
		if [ $? -eq 0 ] ; then
			if [ -z "$3" ] ; then
				echo "Hum you must provide a password for user : $2 "
				exit 1
			else
				echo "${2}:${3}" | /usr/sbin/chpasswd
				echo "Password for A.D.M. user : $2 changed to $3 "
			fi
		else 
			echo "Hum user $2 seem to don't exist in A.D.M. password file"
			exit 1
		fi
	fi
;;
change_${NS_HOST}_password)
	if [ -z "$2" ] ; then
		echo "Hum you must provide a user_name and a password"
		exit 1
	else
		grep -q "^${2}:" /etc/passwd
		if [ $? -eq 0 ] ; then
			if [ -z "$3" ] ; then
				echo "Hum you must provide a password for user : $2 "
				exit 1
			else
				/usr/local/bin/${NS_HOST}_root "echo "${2}:${3}" | /usr/sbin/chpasswd"
				echo "Password for ${NS_HOST} user : $2 changed to $3 "
			fi
		else 
			echo "Hum user $2 seem to don't exist in A.D.M. password file"
			exit 1
		fi
	fi
;;
change_all_password)
if [ -z "$2" ] ; then
		echo "Hum you must provide a user_name and a password"
		exit 1
	else
		grep -q "^${2}:" /etc/passwd
		if [ $? -eq 0 ] ; then
			if [ -z "$3" ] ; then
				echo "Hum you must provide a password for user : $2 "
				exit 1
			else
				$0 change_adm_password ${2} ${3}
				sleep 1
				$0 change_${NS_HOST}_password ${2} ${3}
			fi
		else 
			echo "Hum user $2 seem to don't exist in A.D.M. password file"
			exit 1
		fi
	fi
	
;;
manage_external_package)
	echo "===== NOT yet implemented ... wait for future update"
;;
reinstall_ubuntu_env)
	echo "clean previous download and reinstall"
	echo "previous ${NS_HOST} will be saved as ${NS_HOST}.prev in QPKG folder "
	if [ -e /tmp/${NS_HOST}.pid ] ; then
		echo "Hum! not possible ... ${NS_HOST} is running ... please stop it : $0 stop"
		exit 1
	fi
	mv ${APKG_FOLDER}/.${NS_HOST}/${UVER} ${APKG_FOLDER}/.${NS_HOST}/${UVER}.prev
	mv ${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_scripts ${APKG_FOLDER}/.${NS_HOST}/${NS_HOST}_${UVER}_scripts.prev
	/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} DOWNLOADED FALSE 
	/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} INSTALLED FALSE 
	FULL=""
	if [ -e /share/Public/.${NS_HOST}_chroot_full ] ; then
		FULL="full"
	fi
	${MYHD_BIN}/download_${NS_HOST}.sh $FULL
	if [ $? -eq 0 ] ; then
		echo "seems all run as well"
		/usr/sbin/applog --level 0 --package "${NS_HOST}" --event "$UVER Ubuntu env. was downloaded / installed ... OK "
	else
		echo "Error during download of $UVER Ubuntu env."
		/usr/sbin/applog --level 1 --package "${NS_HOST}" --event "$UVER Ubuntu env. was not downloaded / installed ... please check "
		exit 1
	fi
	echo "Normally NOW $UVER base image is already loaded & installed"
;;
enter_as_root)
	if [ -e /tmp/${NS_HOST}.pid ] ; then
		echo "===== use exit to quit root user in ${NS_HOST}"
        /usr/local/bin/${NS_HOST}_root 
    else
        echo "${NS_HOST} don't run ??? so nothing to do ... "
        exit 1
    fi
;;
enter_as_user)
	if [ -e /tmp/${NS_HOST}.pid ] ; then
		echo "===== use exit to quit $2 user in ${NS_HOST}"
         /usr/local/bin/${NS_HOST}_user "$2"
    else
        echo "${NS_HOST} don't run ??? so nothing to do ... "
        exit 1
    fi
;;
list_valid_folder)
	echo "==== list of valid folder able to be mounted in ${NS_HOST} : "
	find /share/* -maxdepth 0 -type d
	echo "==== list folder include in ${NS_HOST} (can be inactive if new entry without restart of ${NS_HOST} )"
	cat ${APKG_PATH}/fstab_include | cut -f 1 -d ":"
	echo "==== list of temporary mounted folder if exist"
	ps -eaf | grep -v grep | grep -q /usr/sbin/dropbear
	if [ $? -eq 0 ] ; then
		/usr/local/bin/${NS_HOST}_root "/bin/mount | /bin/grep sshfs | /usr/bin/cut -f 3 -d ' '"
	fi
	echo "==== end of list"
;;
list_temporary_mounted_folder)
	echo "==== list of temporary mounted folder if exist"
	ps -eaf | grep -v grep | grep -q /usr/sbin/dropbear
	if [ $? -eq 0 ] ; then
		/usr/local/bin/${NS_HOST}_root "/bin/mount | /bin/grep sshfs | /usr/bin/cut -f 3 -d ' '"
	fi
	echo "==== end of list"
;;
mount_temporary_folder)
	ps -eaf | grep -v grep | grep -q /usr/sbin/dropbear
	if [ $? -eq 0 ] ; then
		ADM_SSH_PORT=$(grep ^Port /usr/etc/ssh/sshd_config | cut -f 2 -d " ")
		if [ -z "${2}" ] ; then
			echo "Please provide a valid folder not already in used"
			$0 list_valid_folder
			exit 1
		else
			grep -q "^${2}:" ${APKG_PATH}/fstab_include
			if [ $? -eq 0 ] ; then
				echo "${2} is ALREADY include in the permanent list "
				exit 1
			else
				grep -q "^${2}" ${APKG_PATH}/fstab_temp
				if [ $? -eq 0 ] ; then
					echo "${2} is ALREADY temporary mounted ??? "
					exit 1
				else
					/usr/local/bin/${NS_HOST}_root "/${NS_HOST}_scripts/bin/mount_via_sshfs.sh ${ADM_SSH_PORT} ${2}"
					/usr/local/bin/${NS_HOST}_root /bin/mount | /bin/grep sshfs | /bin/grep -q " ${2} "
					if [ $? -eq 0 ] ; then
						echo "${2}" >> ${APKG_PATH}/fstab_temp
					fi
				fi
			fi
		fi
	fi
;;
umount_temporary_folder)
	if [ -z "${2}" ] ; then
		echo "Please provide a valid mounted folder temporary (sshfs)"
		$0 list_temporary_mounted_folder
		exit 1
	else
		grep -q "${2}" ${APKG_PATH}/fstab_temp
		if [ $? -eq 0 ] ; then
			/usr/local/bin/${NS_HOST}_root /bin/umount ${2}
			# PROBLEM WITH using / in $2 can't replace / by + as GNU sed can sed -i "/${2}/d" ${APKG_PATH}/fstab_temp
			POS=$(grep -n "^${2}" ${APKG_PATH}/fstab_temp | cut -f 1 -d ":")
			sed -i "${POS}d" ${APKG_PATH}/fstab_temp
		else
			echo "are you sure this folder is mounted ?"
			$0 list_temporary_mounted_folder
			exit 1
		fi
	fi
;;
add_include_folder)
	if [ -z "${2}" ] ; then
		echo "Please provide at minima a folder link name present in /share ex.: /share/Web (and an optional mount point if not the same"
		echo "==== valid folder list is here : "
		find /share/* -maxdepth 0 -type d
		echo "==== end of list"
		exit 1
	else
		F_CAR=$(echo "$2" | cut -c 1)
		if [ "${F_CAR}" = "/" ] ; then
			if [ -e "${2}" ] ; then
				grep -q "^${2}:" ${APKG_PATH}/fstab_include
				if [ $? -eq 0 ] ; then
					echo "${2} is ALREADY include in the list"
					exit 1
				else
					PATH1="${2}"
					if [ "${PATH1:$((${#PATH1}-1)):1}" = "/" ] ; then
						P1="${PATH1%?}"
					else
						P1="${PATH1}"
					fi
					P2=""
					if [ ! -z "${3}" ] ; then
						PATH1="${3}"
						if [ "${PATH1:$((${#PATH1}-1)):1}" = "/" ] ; then
							P2="${PATH1%?}"	
						else
							P2="${PATH1}"
						fi
					fi
					echo "${P1}:${P2}" >> ${APKG_PATH}/fstab_include
				fi
			fi
		else
			# only for WebUI in few time add generation of the find.out file
			POS=${2}
			if [ -z "${POS//[0-9]}" ] ; then
				PATH1=$(sed -n "${POS}p" < /tmp/${NS_HOST}_find.out)
				grep -q "^${PATH1}:" ${APKG_PATH}/fstab_include
				if [ $? -eq 0 ] ; then
					echo "${2} is ALREADY include in the list"
					rm -f /tmp/${NS_HOST}_find.out
					exit 1
				else
					### now nPATH is the same
					echo "${PATH1}:${PATH1}" >> ${APKG_PATH}/fstab_include
					#rm -f /tmp/${NS_HOST}_find.out
				fi
			else
				echo "Hum! not a Path and not a position ???"
				rm -f /tmp/${NS_HOST}_find.out
				exit 1
			fi
		fi
	fi
;;
list_include_folder)
	echo "==== List of already included folder / link and (after the : )mount point in ${NS_HOST} (empty = same PATH)"
	cat ${APKG_PATH}/fstab_include
	echo "==== End of list "
;;
remove_include_folder)
	if [ -z "$2" ] ; then
		echo "Please provide the PATH name from the folder list hereafter"
		cat ${APKG_PATH}/fstab_include | cut -f 1 -d ":"
		exit 1
	else
		F_CAR=$(echo "$2" | cut -c 1)
		if [ "${F_CAR}" = "/" ] ; then
			grep -nq "${2}:" ${APKG_PATH}/fstab_include
			if [ $? -eq 0 ] ; then
		### inside the list
				NB=$(grep -n "${2}:" ${APKG_PATH}/fstab_include | cut -f 1 -d ":")
				/bin/sed -i "${NB}d" ${APKG_PATH}/fstab_include
			else
				echo "This folder : $2 is NOT in the include list"
				cat ${APKG_PATH}/fstab_include | cut -f 1 -d ":"
				exit 1
			fi
		else
			POS=${2}
			if [ -z "${POS//[0-9]}" ] ; then
				# a number follow
				echo "Remove folder : $(sed -n "${POS}p" < /usr/local/AppCentral/${NS_HOST}/fstab_include)" 
				sed -i "${POS}d" /usr/local/AppCentral/${NS_HOST}/fstab_include			
			else
				echo "Hum! not a Path and not a position ???"
				exit 1
			fi
		fi
	fi
;;
clone_user)
	if [ -z "$2" ] ; then
		echo "Please provide an existing A.D.M. user name as second paramter"
		exit 1
	fi
	${APKG_PATH}/bin/move_user.sh "$2"
;;
list_user_define)
	echo "==== List of user know by ${NS_HOST}"
        list_user
        echo "===="
;;
apt_upgrade_package)
	if [ -e /tmp/${NS_HOST}.pid ] ; then
		/usr/local/bin/${NS_HOST}_root "/${NS_HOST}_scripts/bin/www_update_ubuntu_package.sh"
		if [ -e ${CHROOT_PATH}/.reboot_if_require_by_update ] ; then
			echo "restart require"
			RESTART="YES"
			rm -f ${CHROOT_PATH}/.reboot_if_require_by_update
		fi
		if [ -e ${CHROOT_PATH}/.noreboot_require ] ; then
			RESTART="NO"
			rm -f ${CHROOT_PATH}/.noreboot_require
		fi
		RESTART_IF_UPD_REQUIRE=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} RESTART_IF_UPD_REQUIRE)
		if [ "$RESTART_IF_UPD_REQUIRE" = "TRUE" ] ; then
			if [ "$RESTART" = "YES" ] ; then
				$0 restart
			fi
		fi
	fi
;;
set_sshd_port)
	if [ -z "$2" ] ; then
		echo "a PORT must be provide as argument"
		echo "$(basename $0) set_sshd_port PORT"
		exit 1
	else
		NEWPORT=${2}
		if [ $(($NEWPORT+0)) -eq 0 ] ; then
			echo "Hum! ERROR dropbear port : ... $NEWPORT is not numeric ???"
			exit 1
		else
			set_dropbear_port
		fi
	fi
;;
reset_ssh_keys)
	test_aswm_running
	test_apkg_enable
	### TEST if  running
	ps -eaf | grep jchroot | grep -q ${NS_HOST}
	if [ $? -ne 0 ] ; then
		echo "Hum! ${NS_HOST} is NOT started ... nothing possible"
		exit 1
	fi
	touch ${APKG_PATH}/${NS_HOST}_fresh_install
	manage_adm_infos_keys
	copy_adm_authorized_keys
;;
restart_dropbear)
	if [ -e /tmp/${NS_HOST}.pid ] ; then
        /usr/local/bin/${NS_HOST}_root "/etc/init.d/dropbear restart"
    else
        echo "${NS_HOST} don't run ??? so nothing to do ... "
        exit 1
    fi
;;
clean_for_backup)
	FULL=""
	if [ "$2" = "full" ] ; then
		FULL="full"
	fi
	clean_for_backup
;;
list_backup_folder)
	echo "===== Backup_folder"
	echo "Backup_folder : $(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} BACKUP_FOLDER)"
	echo "====="
;;
backup_env)
	BACKUP_FOLDER=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} BACKUP_FOLDER)
	if [ -e /tmp/${NS_HOST}.pid ] ; then
        echo "PLEASE STOP ${NS_HOST} ($(basename $0) stop) ... before creating backup/snapshot "
		exit 1
    else
		if [ ! -e ${BACKUP_FOLDER} ] ; then
			mkdir -p ${BACKUP_FOLDER}
		fi
		PWD=$(pwd)
		cd ${APKG_FOLDER}/.${NS_HOST}
		echo "Start saving scripts folder "
		if [ -e ${BACKUP_FOLDER}/${NS_HOST}_${UVER}_scripts.tgz ] ; then
			rm -f ${BACKUP_FOLDER}/${NS_HOST}_${UVER}_scripts.tgz
		fi
		tar -c -I ${APKG_PATH}/bin/pigz -f ${BACKUP_FOLDER}/${NS_HOST}_${UVER}_scripts.tgz ${NS_HOST}_${UVER}_scripts 
		echo "Start saving USERS HOME folders"
		if [ -e ${BACKUP_FOLDER}/${NS_HOST}_${UVER}_home.tgz ] ; then
			rm -f ${BACKUP_FOLDER}/${NS_HOST}_${UVER}_home.tgz
		fi
		tar -c -I ${APKG_PATH}/bin/pigz -f ${BACKUP_FOLDER}/${NS_HOST}_${UVER}_home.tgz ${NS_HOST}_${UVER}_home 
		echo "Start saving complete (except HOME) Ubuntu environment"
		#### here full or incremental
		if [ "$2" = "full" ] ; then
			rm -f ${BACKUP_FOLDER}/${NS_HOST}_B_* 2>/dev/null
			/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} TARNB 0 
		fi
		PART=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} TARNB)
		if [ ! -e ${BACKUP_FOLDER}/${NS_HOST}_B_${PART}.tgz ] ; then
			tar -c -I ${APKG_PATH}/bin/pigz --listed-incremental=${BACKUP_FOLDER}/${NS_HOST}_B_I.snar -f ${BACKUP_FOLDER}/${NS_HOST}_B_${PART}.tgz ${UVER}
			if [ $? -eq 0 ] ; then
				PART=$(($PART+1))
				/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} TARNB $PART 
			else
				echo "Hum! tar failed ... please analyse and do it manually"
			fi
		else
			echo "ERROR in backup seem file already exist"
			exit 1
		fi
	fi
;;
backup_home)
	BACKUP_FOLDER=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} BACKUP_FOLDER)
	if [ -e /tmp/${NS_HOST}.pid ] ; then
        echo "PLEASE STOP ${NS_HOST} ($(basename $0) stop) ... before creating backup/snapshot "
		exit 1
    else
		if [ ! -e ${BACKUP_FOLDER} ] ; then
			mkdir -p ${BACKUP_FOLDER}
		fi
		PWD=$(pwd)
		cd ${APKG_FOLDER}/.${NS_HOST}
		echo "Start saving USERS HOME folders"
		if [ -e ${BACKUP_FOLDER}/${NS_HOST}_${UVER}_home.tgz ] ; then
			rm -f ${BACKUP_FOLDER}/${NS_HOST}_${UVER}_home.tgz
		fi
		tar -c -I ${APKG_PATH}/bin/pigz -f ${BACKUP_FOLDER}/${NS_HOST}_${UVER}_home.tgz ${NS_HOST}_${UVER}_home 
	fi
;;
set_backup_folder)
	BACKUP_FOLDER=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} BACKUP_FOLDER)
	echo "Actual previous backup folder is : ${BACKUP_FOLDER} "
	if [ -e "$2" ] ; then
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} BACKUP_FOLDER "$2" 
	else
		if [ -e "$(dirname $2)" ] ; then
			mkdir -p "$2"
			echo " $2 created "
			/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} BACKUP_FOLDER "$2" 
		else
			echo "Hum folder $2 ... OR directory base of the folder $(dirname $2) seem to don't exist"
			exit 1
		fi
	fi
	BACKUP_FOLDER=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} BACKUP_FOLDER)
	echo "Actual new backup folder is : ${BACKUP_FOLDER} "
;;
set_update_at_boot)
	if [ "$2" = "on" ] ; then
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} UPDATE_AT_BOOT "TRUE" 
	elif [ "$2" = "off" ] ; then
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} UPDATE_AT_BOOT FALSE 
	else
		echo "$(basename $0) set_update_at_boot REQUIRE another argument on/off "
		echo "$(basename $0) set_update_at_boot [on|off] ... set on or disable (off) update after start of ${NS_HOST}"
	fi 
;;
set_restart_if_update_require)
	if [ "$2" = "on" ] ; then
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} RESTART_IF_UPD_REQUIRE "TRUE" 
	elif [ "$2" = "off" ] ; then
		/usr/bin/confutil -set ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} RESTART_IF_UPD_REQUIRE FALSE 
	else
		echo "$(basename $0) set_restart_if_update_require REQUIRE another argument on/off "
		echo "$(basename $0) set_restart_if_update_require [on|off] ... set on or disable (off) restart after update of ${NS_HOST}"
	fi
;;
list_mounted_folder)
	echo "====== List of mounted folder ... MUST be empty on uninstall"
	if [ -e /tmp/${NS_HOST}.pid ] ; then
		ps -eaf | grep jchroot | grep -q ${NS_HOST}
			if [ $? -eq 0 ] ; then
				/usr/local/bin/${NS_HOST}_root "mount | grep share > /${NS_HOST}_temp/mount.out"
                # echo "===== result"
                cat ${APKG_PATH}/${NS_HOST}_temp/mount.out
			else
				echo "Hum! ${NS_HOST} is not running "
			fi
	else
		echo "Hum! ${NS_HOST} is not running "
	fi
	echo "======"
;;
*)
	usage
;;
esac
