#!/bin/bash
# set -x
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/bin/X11:/usr/local/sbin:/usr/local/bin:/usr/local/jre/bin
NS_HOST=myHD
cd /root
if [ ! -e .ssh ] ; then
	mkdir .ssh
fi
chmod 700 .ssh
if [ -e .ssh/id_rsa -a -e .ssh/id_rsa.pub ] ; then
	echo "keys for sshfs already generated"
	rm /.keys.tmp
	exit 0
else
	/usr/bin/ssh-keygen -t rsa -N "" -C "myHD_root" -f /root/.ssh/id_rsa
fi
chmod 600 .ssh/id_rsa
sleep 1
rm /.keys.tmp
