#!/bin/bash

case "$1" in
start)
	if [ -e /etc/mtab ] ; then
		echo "Hum! not all dysmounted"
		$0 stop
		rm -f /etc/mtab
	fi
	mount -t devtmpfs udev /dev
	if [ ! -e /dev/pts ] ; then
		mkdir /dev/pts
	fi
	mount -t devpts devpts /dev/pts
	mount -t proc proc /proc
	mount -t sysfs sys /sys
	[ -d /run ] || mkdir -p /run
	mount -t tmpfs tmpfs /run
	[ -d /run/shm ] || mkdir -p /run/shm
	mount -t tmpfs none /run/shm
	[ -d /run/lock ] || mkdir -p /run/lock
	mount -t tmpfs none /run/lock
##### Alsready done in Asustor side
        ln -sf /run/shm /dev/shm
####
	ln -sf /run/shm /dev/shm
    if [ ! -e /dev/fd ] ; then
		ln -sf /proc/self/fd /dev/fd
    fi
;;
stop)
	umount  /run/lock
	umount  /run/shm
	umount  /run
	umount /sys
	umount /proc
	umount /dev/pts
	umount /dev
;;
*)
	echo "$0 start|stop"
;;
esac

