#!/bin/sh
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/bin/X11:/usr/local/sbin:/usr/local/bin:/usr/local/jre/bin
NS_HOST=myHD
##
non_inter(){
DEBIAN_FRONTEND=noninteractive \
  apt-get \
  -o Dpkg::Options::=--force-confold \
  -o Dpkg::Options::=--force-confdef \
  -y --allow-downgrades --allow-remove-essential --allow-change-held-packages \
  dist-upgrade
}
##
normal(){
/usr/bin/apt-get -y dist-upgrade | /usr/bin/tee /tmp/${NS_HOST}_root.out
}
##

rm -f /${NS_HOST}_temp/apt_update.out 
echo "==== START UPDATE LOG =====" > /${NS_HOST}_temp/apt_update.out
# /usr/bin/apt-get update >>/${NS_HOST}_temp/apt_update.out 2>&1
/usr/bin/apt-get update 2>&1 | /usr/bin/tee -a /${NS_HOST}_temp/apt_update.out
## /usr/bin/apt-get -y dist-upgrade >>/${NS_HOST}_temp/apt_update.out 2>&1
# non_inter >>/${NS_HOST}_temp/apt_update.out 2>&1
non_inter 2>&1 | /usr/bin/tee -a /${NS_HOST}_temp/apt_update.out
sleep 1
/usr/bin/apt-get -y autoremove 2>&1 | /usr/bin/tee -a /${NS_HOST}_temp/apt_update.out
/usr/bin/apt-get -y clean 2>&1 | /usr/bin/tee -a /${NS_HOST}_temp/apt_update.out

if [ -e /var/run/reboot-required ] ; then
	echo "<b>====== ATTENTION a RESTART of ${NS_HOST} is REQUIRED </b>"
fi
echo "===== END OF UPDATE LOG ====" >>/${NS_HOST}_temp/apt_update.out
