#!/bin/sh
#
# $Id: apkg_mgnt.cgi 2018 inspired by package.cgi from Optware $(credits to us)
# original base of : $Id: package.cgi 6240 2007-06-17 22:29:05Z marceln $
#
GREEN="font color=#00FF00"
RED="font color=#FF0000"
BLEU="font color=#0000FF"
BLACK="font color=#000000"
NC="/font"
NS_HOST=myHD
APKG_PATH=/usr/local/AppCentral/${NS_HOST}
UVER=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} UVER)
CHRT=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} CHRT)
MYHD_BIN=/usr/local/bin
INSTALLED=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}_${UVER}.conf ${UVER} INSTALLED)
LANG="$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} LANG_WEBUI)"
ENA="$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} WEBUI)"

source /share/Web/${NS_HOST}/text/en/apkg_mgr.data

if [ "$LANG" != "en" ] ; then
	if [ -e /share/Web/${NS_HOST}/text/${LANG}/apkg_mgr.data ] ; then
		source /share/Web/${NS_HOST}/text/${LANG}/apkg_mgr.data
	fi 
fi

fill_col_gauche(){
echo "<td valign=top>"
# menu status
echo -n "<a class="button-launch" href="?STATUS=YES"><$BLACK>Status </font></a>"
echo "<br>"
if [ "$INSTALLED" = "TRUE" ] ; then
	# menu start / stop /restart 
	ps -eaf | grep jchroot | grep -q ${NS_HOST}
	if [ $? -eq 0 ] ; then
		## 
		echo -n "<a class="button-launch" href="?STOP=YES"><$RED>${BU001}</font></a>"
		echo "<br>"
		echo -n "<a class="button-launch" href="?RESTART=YES"><$RED>${BU002}</font></a>"
	else
		echo -n "<a class="button-launch" href="?START=YES"><$GREEN>${BU003}</font></a>"
	fi
	echo "<br><br>"
	if [ "${CHRT}" = "jchroot" ] ; then
		echo -n "<a class="button-launch" href="?JINIT=YES"><$BLACK>${BU014}</font></a>"
	else
		echo -n "<a class="button-launch" href="?JCHROOT=YES"><$BLACK>${BU015}</font></a>"
	fi
	echo "<br><br>"
	echo -n "<a class="button-launch" href="?MOUNTED_F=YES"><$BLACK>${BU004}</font></a>"
	echo "<br><br>"
	echo -n "<a class="button-launch" href="?UPD=YES"><$BLACK>${BU005}</font></a>"
	echo "<br><br>"
	echo "<a class="button-launch" href="myhd_apkg.cgi"><$BLEU>${BU006}<$NC></a>"
	echo "<br>"
	echo "<a class="button-launch" href="myhd_shared.cgi"><$BLEU>${BU007}<$NC></a>"

	echo "<br>"
	echo "<br>"
	echo "<br>"
fi
	echo "<br>"
	echo "</td>"
}

fill_col_droite(){
echo "<td valign=top>"
case $ACT in
	STATUS)
		echo "<p>${RT001} </p>"
		echo "<br>"
		echo "<pre>"
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh status www
		echo "</pre>"
		echo "<br>"
		echo -n "<a class="button-launch" href="?STATUS=YES"><$BLACK>${BU008}</font></a>"
		echo "<a class="button-launch" href="apkg_mgr.cgi">${BU009}</a>"
		;;
	START|STOP|RESTART)
		echo "<p>${RT002}<b>$ACT</b> ${NS_HOST} </p>"
		echo "<br>"
		echo -n "<a class="button-launch" href="apkg_mgr.cgi"><font color=#000000>${BU010}</font></a>"
		echo -n "&nbsp;&nbsp;"
		echo -n "<a class="button-launch" href="apkg_mgr.cgi?CONFIRM=$ACT"><font color=#000000>${BU011}</font></a>"
		echo "<br>"
		;;
	JINIT)
		echo "<p>${RT009} </p>"
		echo "<br>"
		### temporary
		echo "<$RED> FOR EXPERT ONLY <$NC>"
		echo "<br>"
		echo "Due to release ALPHA for using systemd init Please temporary use : ${NS_HOST} command in a terminal"
		#echo "<pre>"
		#/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh set_use_jinit
		#echo "</pre>"		
		echo "<br>"
		echo "<a class="button-launch" href="apkg_mgr.cgi">${BU012}</a>"
		;;
	JCHROOT)
		echo "<p>${RT010} </p>"
		echo "<br>"
		echo "<pre>"
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh set_use_jchroot
		echo "</pre>"		
		echo "<br>"
		echo "<a class="button-launch" href="apkg_mgr.cgi">${BU012}</a>"
		;;
	CONFIRM)
		echo "<p>${RT003} $VAL</p>"
		echo "<pre>"
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh "$(echo $VAL | tr '[A-Z]' '[a-z]')"
		echo "</pre>"		
		echo "<br>"
		echo "<a class="button-launch" href="apkg_mgr.cgi">${BU012}</a>"
		;;
	LIST_F)
		echo "<p>${RT004} </p>"
		echo "<pre>"
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh list_include_folder
		echo "</pre>"		
		echo "<br>"
		echo "<a class="button-launch" href="apkg_mgr.cgi">${BU012}</a>"
		;;
	MOUNTED_F)
		echo "<p>${RT005}</p>"
		echo "<pre>"
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh list_mounted_folder
		#/usr/local/bin/${NS_HOST}_root "mount | grep share"
		echo "</pre>"		
		echo "<br>"
		echo "<a class="button-launch" href="apkg_mgr.cgi">${BU012}</a>"
		;;
	UPD)
		echo "<p>${RT006}</p>"
		echo "<pre>"
		rm -f /usr/local/AppCentral/${NS_HOST}/${NS_HOST}_temp/apt_update.out
		# /usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh apt_upgrade_package
		if [ "$CHRT" = "jchroot" ] ; then
			/usr/builtin/bin/sudo -u root /usr/local/bin/tmux send-keys -t ${NS_HOST} "/myHD_scripts/bin/www_update_ubuntu_package.sh" Enter
		else
			/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh apt_upgrade_package &
		fi
		echo "<b>${RT007}</b>"
		echo "<br>"
		echo "<b>${RT008}</b>"
		sleep 2
		cat /usr/local/AppCentral/${NS_HOST}/${NS_HOST}_temp/apt_update.out	
		echo "</pre>"
		echo "<br><br>"
		echo -n "<a class="button-launch" href="apkg_mgr.cgi?REFRESH=YES"><font color=#000000>${BU013}</font></a>"
		echo "<a class="button-launch" href="apkg_mgr.cgi">${BU012}</a>"
		;;
	REFRESH)
		echo "<p>${RT006}</p>"
		echo "<b>${RT007}</b>"
		echo "<br>"
		echo "<b>${RT008}"
		echo "<pre>"
		cat /usr/local/AppCentral/${NS_HOST}/${NS_HOST}_temp/apt_update.out	
		echo "</pre>"
		echo "<br><br>"
		echo -n "<a class="button-launch" href="apkg_mgr.cgi?REFRESH=YES"><font color=#000000>${BU013}</font></a>"
		echo "<a class="button-launch" href="apkg_mgr.cgi">${BU012}</a>"
		;;
	*)	
	# http://${SERVER_NAME}:81
		echo "<br>"
		echo "${TT001}"
		echo "<br>"
		echo "<br><b>${TT002}</b> ${TT003}<br><br>"
		echo "<h3>${TT004}</h3>"
		echo "<p>${TT005}</p>"
		echo "<p>${TT006}</p>"
		echo "<p>${TT007}</p>"
		;;
esac
echo "</td>"
}

cat /usr/local/AppCentral/${NS_HOST}/www/entete.in
echo "<style type="text/css">"
cat /usr/local/AppCentral/${NS_HOST}/www/css.css
# cat /share/Web/apkg_mgr/css_menu.css
echo "</style>"
echo "</head>"
echo "<body>"

## debug echo "<b> ::::::: "$HTTP_REFERER
if [ "$ENA" != "TRUE" ] ; then
	echo "<b>ERROR</b>: WebUI Disable by Admin (use ${NS_HOST} in terminal to enable it)"
	echo '</body>'
	echo '</html>'
	exit 1
fi
echo "<h1>${TT010}</h1>"
PKG=myHD
IFS='&'
set -- ${QUERY_STRING}
for i in "$@"
do
	case ${i%%=*} in
		STATUS)
			ACT="STATUS"
			VAL="${i#*=}"
			;;
		START)
			ACT="START"
			VAL="${i#*=}"
			;;
		FSTART)
			ACT="FSTART"
			VAL="${i#*=}"
			;;
		STOP)
			ACT="STOP"
			VAL="${i#*=}"
			;;
		RESTART)
			ACT="RESTART"
			VAL="${i#*=}"
			;;
		CONFIRM)
			ACT="CONFIRM"
			VAL="${i#*=}"
			;;
		LIST_F)
			ACT="LIST_F"
			VAL="${i#*=}"
			;;
		MOUNTED_F)
			ACT="MOUNTED_F"
			VAL="${i#*=}"
			;;
		UPD)
			ACT="UPD"
			VAL="${i#*=}"
			;;
		REFRESH)
			ACT="REFRESH"
			VAL="${i#*=}"
			;;
		JINIT)
			ACT="JINIT"
			VAL="${i#*=}"
			;;
		JCHROOT)
			ACT="JCHROOT"
			VAL="${i#*=}"
			;;
		*)
			echo "<b>ERROR</b>: Unknown option '${i}'"
			echo "<br><br>"
			echo "<a class="button-link" href="apkg_mgr.cgi">${BU012}</a>"
			echo '</body>'
			echo '</html>'
			exit 1
			;;
	esac
done
# cat /share/Web/apkg_mgr/menu.in
echo '<table border="2" cellpadding="0" cellspacing="0" style="width:1366px">'
echo '<tr><th width=200px> Menu </th><th> Actions </th></tr>'
	fill_col_gauche
	fill_col_droite
echo '</table>'
#if [ ! -z "$HTTP_REFERER" ] ; then
#		echo "<p> $HTTP_REFERER </p>"

# fi
echo '</body>'
echo '</html>'
