#!/bin/sh
#
# $Id: qpkg_mgnt.cgi 2013 inspired by package.cgi from Optware $(credits to us)
# original base of : $Id: package.cgi 6240 2007-06-17 22:29:05Z marceln $
#
GREEN="font color=#00FF00"
RED="font color=#FF0000"
BLEU="font color=#0000FF"
BLACK="font color=#000000"
NC="/font"
BOLD="<b>"
UNBOLD="</b>"
NS_HOST=myHD
APKG_PATH=/usr/local/AppCentral/${NS_HOST}
UVER=$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} UVER)
LANG="$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} LANG_WEBUI)"

source /share/Web/${NS_HOST}/text/en/myhd_apkg.data

message_info(){
	echo "<h3>${LT001}</h3>"
	echo "<br>"
	echo "<b>${LT002}</b>${LT003}"
	echo "<br>"
	echo "<b>${LT004}</b>${LT005}"
	echo "<br><br>"
	echo "<b>${LT006}</b>"
	echo "<br>"
}

if [ "$LANG" != "en" ] ; then
	if [ -e /share/Web/${NS_HOST}/text/${LANG}/myhd_apkg.data ] ; then
		source /share/Web/${NS_HOST}/text/${LANG}/myhd_apkg.data
	fi 
fi
fill_col_gauche(){
echo "<td valign=top>"
		echo "<br>"
		echo -n "<a class="button-launch" href="?STORE=YES"><$BLACK>${BU007}</$NC></a>"
		echo "<br>"
		echo -n "<a class="button-launch" href="?INSTALL_APP=YES"><$BLACK>${BU008}</$NC></a>"
		echo "<br><br>"
        #echo -n "<a class="button-launch" href="?STATUS=YES"><$BLACK>${BU003}</$NC></a>"
		#echo "<br>"
        echo -n "<a class="button-launch" href="?MHALL=YES"><$BLACK>${BU002}</$NC></a>"
		echo "<br>"
		echo -n "<a class="button-launch" href="?AUTOAPP=YES"><$BLACK>${BU005}</$NC></a>"
		echo "<br>"
		echo -n "<a class="button-launch" href="?SETAUTO=YES"><$BLACK>${BU006}</$NC></a>"
        echo "<br><br>"
        echo -n "<a class="button-launch" href="apkg_mgr.cgi"><$BLEU>${BU001}</font></a>"
echo "</td>"
}

fill_col_droite(){
echo "<td>"
case $CONF in
    STATUS)
		echo "<pre>"
		#/usr/builtin/bin/sudo -u root /usr/local/bin/${NS_HOST}_apkg status www
		echo "</pre>"
		echo "<br><br>"
		;;
	STORE)
		echo "<pre>"
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh get_App_available www
		echo "</pre>"
		echo "<br><br>"
		;;
	MHALL)
		echo "<pre>"
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh list_all_installed_apkg www
		echo "</pre>"
		echo "<br><br>"
		;;
	AUTOAPP)
		echo "<pre>"
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh list_my_autorun
		echo "</pre>"
		echo "<br><br>"
		;;
	SETAUTO)
		echo -n "<FORM method="GET" action="?ADD=YES">"
		echo "${RT004}"
		echo "<br>"
		echo -n "<input type="radio" name="APATH" value="NONE" checked> ${RT003}<br>"
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh list_available_app_for_autorun | grep -v '=' > /tmp/app_list.out
		while IFS= read F
		do
			echo -n "<input type="radio" name="APATH" value="${F}" > ${F}<br>"
		done < /tmp/app_list.out
		rm -f /tmp/app_list.out
		echo "<br>"
		echo "<INPUT type="submit" value="ADDING">"
		echo -n "</FORM>"
		;;
	INSTALL_APP)
		echo -n "<FORM method="GET" action="?INS=YES">"
		echo "${RT005}"
		echo "<br>"
		echo -n "<input type="radio" name="APP" value="NONE" checked> ${RT003}<br>"
		# fill ${APKG_PATH}/${NS_HOST}_Apps_list 
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh get_App_available > /dev/null
		while IFS= read F
		do
			A_NAME=$(echo "$F" | cut -f 1 -d ":")
			A_VER=$(echo "$F" | cut -f 2 -d ":")
			MIN_VER="$(echo "$F" | cut -f 3 -d ':')"
			if [ -z "${MIN_VER}" ] ; then
				MIN_VER="Unknown"
			fi
			COMMENT="$(echo "$F" | cut -f 4 -d ':')"
			INSTALLED="NO"
			grep -q "^${A_NAME}:" /tmp/${NS_HOST}_installed
			if [ $? -eq 0 ] ; then
				INSTALLED="${BOLD}YES${UNBOLD}"
			fi
			echo -n "<input type="radio" name="APP" value="${A_NAME}_${A_VER}" > ${BOLD}${A_NAME}${UNBOLD} ... Version ${A_VER} Installed : ${INSTALLED} for ${NS_HOST} ver. ${MIN_VER} ${COMMENT} <br>"
		done < /tmp/${NS_HOST}_Apps_instalable
		echo "<br>"
		echo "<INPUT type="submit" value="INSTALL">"
		echo -n "</FORM>"
		;;
	*)
		if [ "$VAL" = "APATH" -o "$VAL" = "APP" ] ; then
			echo "<br>"
		else
			echo "<br><br>"
			echo "<h3>${TT001}</h3>"
		fi
		;;
esac
case $VAL in
	APATH)
		echo "${RT007} ${APATH}"
		echo "<br>"
		echo "<pre>"
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh set_my_autorun ${APATH}
		echo "</pre>"
		echo "<br>"
		echo "done"
		;;
	APP)
		A_NAME=$(echo "${APP}" | cut -f 1 -d "_")
		A_VER=$(echo "${APP}" | cut -f 2 -d "_")
		echo "${RT008} ${A_NAME} ${A_VER}"
		echo "<br>"
		echo "<pre>"
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh install_App_from_store ${A_NAME} ${A_VER}
		echo "</pre>"
		echo "<br>"
		echo "done"
		;;
	*)
		:
		;;
esac
echo "<br>"
echo -n "<a class="button-launch" href="myhd_apkg.cgi"><$BLEU>${BU004}</font></a>"
echo "</td>"
}
		
cat /usr/local/AppCentral/${NS_HOST}/www/entete.in
echo "<style type="text/css">"
cat /usr/local/AppCentral/${NS_HOST}/www/css.css
# cat /share/Web/apkg_mgr/css_menu.css
echo "</style>"
echo "</head>"
echo "<body>"

echo "<h1>myHD Apkg Interface management</h1>"
if [ -z "$HTTP_REFERER" ] ; then
        echo "<p>${ER001}</p>"
        echo "<br><br>"
		echo '</body>'
		echo '</html>'
		exit 0
else
	# for debugecho "<b> ::::::: "$HTTP_REFERER""
	echo "$HTTP_REFERER" | grep -q apkg_mgr.cgi
	if [ $? -ne 0 ] ; then
		echo "$HTTP_REFERER" | grep -q "myhd_apkg.cgi"
		if [ $? -ne 0 ] ; then
			echo "<p>${ER002} $HTTP_REFERER</p>"
			echo "<br><br>"
			echo '</body>'
			echo '</html>'
			exit 0
		fi
	fi
fi

CONFIRM=""
PKG=${NS_HOST}
CONF=""
IFS='&'
set -- ${QUERY_STRING}
for i in "$@"
do
        case ${i%%=*} in
                STATUS)
                        CONF="STATUS"
                        VAL="${i#*=}"
                        ;;
				STORE)
                        CONF="STORE"
                        VAL="${i#*=}"
                        ;;
				MHALL)
						CONF="MHALL"
						VAL="${i#*=}"
						;;
				AUTOAPP)
						CONF="AUTOAPP"
						VAL="${i#*=}"
						;;
				SETAUTO)
						CONF="SETAUTO"
						VAL="${i#*=}"
						;;
				INSTALL_APP)
						CONF="INSTALL_APP"
						VAL="${i#*=}"
						;;
				APATH)
						VAL="APATH"
						APATH=$(echo "${i#*=}" | sed 's/%2F/\//g')
						;;
				APP)
						VAL="APP"
						APP=$(echo "${i#*=}" | sed 's/%2F/\//g')
						;;
                submit|ADD|INS)
                        ;;
                *)
                        echo "<b>ERROR</b>: Unknown option '${i}'"
                        echo "<br><br>"
                        echo "<a class="button-link" href="apkg_mgr.cgi"><$BLEU>${BU001}<$NC></a>"
                        echo '</body>'
                        echo '</html>'
                        exit 1
                        ;;
        esac
done

echo '<table border="2" cellpadding="0" cellspacing="0" style="width:1366px">'
echo '<tr><th width=200px> Menu </th><th> Actions </th></tr>'
        fill_col_gauche
        fill_col_droite
echo '</table>'
#
echo '</body>'
echo '</html>'
