#!/bin/sh
NS_HOST=myHD
echo "Uninstall ALL MH-xxx apkg installed"
echo "Please wait to end ... we verify that APKG is really suppress"
echo "... so I wait for up to 20 sec to let time for Asustor APKG manager to do the job"
echo ""
echo "====="
echo "List of MH-apkg / MH18-apkg or MH16-apkg installed"
/usr/sbin/apkg --list | grep ^MH
echo "====="
for N in $(/usr/sbin/apkg --list | grep ^MH | cut -f 1 -d " ")
	do
		echo "Queued request to disable then remove QPKG : $N "
		/usr/sbin/apkg --disable ${N}
		sleep 1
		/usr/sbin/apkg --remove ${N}
		sleep 1
		NB=20
		while [ $NB -gt 0 ]
		do
			/usr/sbin/apkg --list | grep -q "${N}"
			if [ $? -eq 0 ] ; then
				### still exist wait max 20 sec
				sleep 2
				NB=$((NB-1))
			else
				### deleted as well 
				break
			fi
		done
		### test NB
		if [ $NB -le 0 ] ; then
			echo "Hum perhaps a problem when removing APKG : $N ... please check "
			echo "Then redo $0"
			echo "Test $N will be done by doing : /usr/sbin/apkg --list | grep ${N} "
		fi
	done 
echo "Please wait up to all ${NS_HOST} will be really removed "
echo "====="
echo "LAST verification : List of MH_qpkg installed (must be empty)"
/usr/sbin/apkg --list | grep ^MH
echo "====="

