#!/bin/sh
NS_HOST=myHD
QPKG_PATH=/usr/local/AppCentral/${NS_HOST}
APKG_FOLDER=/usr/local/
MYHD_BIN=${QPKG_PATH}/bin
UVER=$(/usr/bin/confutil -get ${QPKG_PATH}/${NS_HOST}.conf ${NS_HOST} UVER)
CHROOT_PATH=${APKG_FOLDER}/.${NS_HOST}/${UVER}

# export PATH=/My/myns/bin:$PATH

NS_HOST="$1"
if [ ! -e /tmp/${NS_HOST}.pid ] ; then
	echo "Not a valid file (pid from jchroot)"
	exit 1
fi
if [ -s  /tmp/${NS_HOST}.pid ] ; then
	echo "File exist and is NOT empty"
else
	echo "Not a valid file (pid from jchroot)"
	rm -f /tmp/${NS_HOST}.pid
fi

while [ -s /tmp/${NS_HOST}.pid -a -e /proc/$(cat /tmp/${NS_HOST}.pid) ]
do
        sleep 2
done
### by security check if mount have residual aspect
### check first visible mount
mount | grep ${NS_HOST}
if [ $? -eq 0 ] ; then 
	for F in $(mount | grep ${NS_HOST} | cut -f 3 -d " ")
	do
		umount $F
	done
fi
### check now hidden mount
grep ${NS_HOST} /proc/mounts
if [ $? -eq 0 ] ; then
	for F in $(cat /proc/mounts | grep ${NS_HOST} | cut -f 2 -d " ")
	do
		umount $F
	done
fi
rm -f /tmp/${NS_HOST}.pid

### if exist remove the pipe for myserv
ps -eaf | grep -v grep | grep -q ${NS_HOST}_serv
if [ $? -eq 0 ] ; then
        echo "quit" > /share/homes/${NS_HOST}_SERVER
	sleep 2
fi

