#!/bin/sh
NAME="myHD"
APKG_PATH=/usr/local/AppCentral/${NAME}

echo "post-install"
case $APKG_PKG_STATUS in
        install)
                echo " case $APKG_PKG_STATUS "
				if [ -e /tmp/.${NAME}_lock ] ; then
					rm -f /tmp/.${NAME}_lock
				fi
				rm -f /tmp/download_${NAME}.log
				rm -f /tmp/start_${NAME}.log
				rm -f /tmp/${NAME}.pid
				touch ${APKG_PATH}/.fresh_install
        ;;
        uninstall)
                echo " case $APKG_PKG_STATUS "
				rm -f /tmp/.${NAME}_lock
				rm -f /tmp/download_${NAME}.log
				rm -f /tmp/start_${NAME}.log
				rm -f /tmp/${NAME}.pid
        ;;
        upgrade)
			    echo " case $APKG_PKG_STATUS "
				rm -f /tmp/.${NAME}_lock
				rm -f /tmp/download_${NAME}.log
				rm -f /tmp/start_${NAME}.log
				rm -f /tmp/${NAME}.pid
				
				if [ -e /usr/local/.${NAME}_save ] ; then
					cp -p /usr/local/.${NAME}_save/fstab_include ${APKG_PATH}/
					cp -p /usr/local/.${NAME}_save/*.conf ${APKG_PATH}/
					cp -pPR /usr/local/.${NAME}_save/${NAME}_apkg ${APKG_PATH}/
					cp -pPR /usr/local/.${NAME}_save/${NAME}_temp ${APKG_PATH}/
					cp -p /usr/local/.${NAME}_save/.htpassword ${APKG_PATH}/bin/
					#
					rm -rf /usr/local/.${NAME}_save
				fi
        ;;
        *)
                /usr/sbin/syslog -g 0 -l 1 --user admin --event "APKG $NAME false $APKG_PKG_STATUS status ??? "
        ;;
esac
