#!/bin/bash
# set -x
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/bin/X11:/usr/local/sbin:/usr/local/bin:/usr/local/jre/bin
NS_HOST=myHD
#
if [ -z "$1" -o -z "$2" ] ; then
	echo "ERROR usage : mount_via_sshfs.sh ADM_SSH_PORT MOUNT_FOLDER"
	echo "FALSE  param 1 = $1 ... param 2 = $2"
	exit 1
fi
ADM_SSH_PORT=$1
MOUNT_FOLDER="${2}"
if [ ! -e ${MOUNT_FOLDER} ] ; then
	mkdir -p ${MOUNT_FOLDER}
	chmod 777 ${MOUNT_FOLDER}
fi
echo " start sshfs with port $1 using folder : $2"
### use /usr/bin/nohup ... to start in background
/usr/bin/nohup /usr/bin/sshfs -p ${ADM_SSH_PORT} -o allow_other,default_permissions -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no root@localhost:${MOUNT_FOLDER} ${MOUNT_FOLDER} > /tmp/$(basename ${MOUNT_FOLDER}).out 
echo "done verify"
mount | grep sshfs
