#!/bin/sh
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/bin/X11:/usr/local/sbin:/usr/local/bin:/usr/local/jre/bin
NS_HOST=myHD
##
non_inter(){
DEBIAN_FRONTEND=noninteractive \
  apt-get \
  -o Dpkg::Options::=--force-confold \
  -o Dpkg::Options::=--force-confdef \
  -y --allow-downgrades --allow-remove-essential --allow-change-held-packages \
  dist-upgrade
}
##
normal(){
/usr/bin/apt-get -y dist-upgrade | /usr/bin/tee /tmp/${NS_HOST}_root.out 
}
##
/usr/bin/apt-get update
non_inter
sleep 2
/usr/bin/apt-get -y autoremove
/usr/bin/apt-get -y clean

rm -f /.reboot_if_require_by_update /.noreboot_require
if [ -e /var/run/reboot-required ] ; then
	touch /.reboot_if_require_by_update
else
	touch /.noreboot_require
fi
