#!/bin/sh
### start for each user : key ssh + asoundrc ...
if [ -z "$HOME" ] ; then
	echo "Hum! why this user don't have a home folder ????"
	exit 1
fi
FOLD=/myHD_scripts/files
# cp ${FOLD}/.asoundrc ${HOME}/
if [ ! -e ${HOME}/.ssh ] ; then
	mkdir ${HOME}/.ssh
fi 
cp ${FOLD}/authorized_keys ${HOME}/.ssh/
chmod 640 ${HOME}/.ssh/authorized_keys

if [ "${1}" != "noaudio" ] ; then
	if [ ! -e ${HOME}/.config/pulse ] ; then
		mkdir -p ${HOME}/.config/pulse
		mkdir -p ${HOME}/.config/pulse/for_jchroot
		cp ${FOLD}/client.conf ${HOME}/.config/pulse/
		cp ${FOLD}/client.conf ${HOME}/.config/pulse/for_jchroot
		cp ${FOLD}/default.pa ${HOME}/.config/pulse/
		cp ${FOLD}/default.pa ${HOME}/.config/pulse/for_jchroot
		cp ${FOLD}/daemon.conf ${HOME}/.config/pulse/
		cp ${FOLD}/daemon.conf ${HOME}/.config/pulse/for_jchroot
	else
		if [ ! -e ${HOME}/.config/pulse/for_jchroot ] ; then
			mkdir -p ${HOME}/.config/pulse/for_jchroot
		fi
		for F in client.conf default.pa daemon.conf
		do
			if [ ! -e ${HOME}/.config/pulse/${F} ] ; then
				if [ -e ${HOME}/.config/pulse/for_jchroot/${F} ] ; then
					cp -p ${HOME}/.config/pulse/for_jchroot/${F} ${HOME}/.config/pulse/
				else
					cp -p ${FOLD}/${F} ${HOME}/.config/pulse/
					cp -p ${FOLD}/${F} ${HOME}/.config/pulse/for_jchroot/
				fi
			else
				if [ ! -e ${HOME}/.config/pulse/for_jchroot/${F} ] ; then
					cp -p ${HOME}/.config/pulse/${F} ${HOME}/.config/pulse/for_jchroot/
				fi
			fi
		done
	fi
else
	rm -f ${HOME}/.config/pulse/client.conf ${HOME}/.config/pulse/default.pa ${HOME}/.config/pulse/daemon.conf
fi
