#!/bin/sh
#
# $Id: qpkg_mgnt.cgi 2013 inspired by package.cgi from Optware $(credits to us)
# original base of : $Id: package.cgi 6240 2007-06-17 22:29:05Z marceln $
#
GREEN="font color=#00FF00"
RED="font color=#FF0000"
BLEU="font color=#0000FF"
BLACK="font color=#000000"
NC="/font"
NS_HOST=myHD
APKG_PATH=/usr/local/AppCentral/${NS_HOST}
LANG="$(/usr/bin/confutil -get ${APKG_PATH}/${NS_HOST}.conf ${NS_HOST} LANG_WEBUI)"

source /share/Web/${NS_HOST}/text/en/myhd_shared.data

if [ "$LANG" != "en" ] ; then
	if [ -e /share/Web/${NS_HOST}/text/${LANG}/myhd_shared.data ] ; then
		source /share/Web/${NS_HOST}/text/${LANG}/myhd_shared.data
	fi 
fi

message_info(){
	echo "<h3>${LT001}</h3>"
	echo "<br>"
	echo "<b>${LT002}</b>${LT003}"
	echo "<br>"
	echo "<b>${LT004}</b>${LT005}"
	echo "<br><br>"
	echo "<b>${LT006}</b>"
	echo "<br>"
}

fill_col_gauche(){
echo "<td valign=top>"
		echo "<br>"
        echo -n "<a class="button-launch" href="?LIST_F=YES"><$BLACK>${BU002}</font></a>"
		echo "<br>"
		echo -n "<a class="button-launch" href="?ADD_F=YES"><$BLACK>${BU003}</font></a>"
        echo "<br>"
		echo -n "<a class="button-launch" href="?REMOVE_F=YES"><$BLACK>${BU004}</font></a>"
        echo "<br><br>"
        echo -n "<a class="button-launch" href="apkg_mgr.cgi"><$BLEU>${BU001}</font></a>"
echo "</td>"
}

fill_col_droite(){
echo "<td valign=top>"
case $CONF in
    LIST_F)
		echo "<p>${RT001}</p>"
		echo "<pre>"
		/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh list_include_folder
		echo "</pre>"		
		echo "<br>"
		;;
	REMOVE_F)
		echo -n "<FORM method="GET" action="?SUPP=YES">"
		echo "${RT002}"
		echo "<br>"
		POS=0
		echo -n "<input type="radio" name="FPATH" value="${POS}" checked> ${RT003}<br>"
		while IFS= read F
		do
			R=$(echo "${F}" | cut -f 1 -d ":")
			F=$(echo "${F}" | cut -f 1 -d ":" | sed -e 's/&/&amp;/g')
			# echo "${R}" > /tmp/myHD_shared.tmp 
			POS=$((POS + 1))
			echo -n "<input type="radio" name="FPATH" value="${POS}" > ${F}<br>"
		done < /usr/local/AppCentral/${NS_HOST}/fstab_include
		echo "<br>"
		echo "<INPUT type="submit" value="SUPPRESS">"
		echo -n "</FORM>"
		;;
	ADD_F)
		echo -n "<FORM method="GET" action="?ADD=YES">"
		echo "${RT004}"
		echo "<br>"
		POS=0
		echo -n "<input type="radio" name="APATH" value="${POS}" checked> ${RT003}<br>"
		find /share/* -maxdepth 0 -type d > /tmp/${NS_HOST}_find.out
		while IFS= read F
		do
			POS=$((POS + 1))
			grep -q "^${F}:" /usr/local/AppCentral/${NS_HOST}/fstab_include
			if [ $? -ne 0 ] ; then
				echo -n "<input type="radio" name="APATH" value="${POS}" > ${F}<br>"
			fi
		done < /tmp/${NS_HOST}_find.out
		#rm -f /tmp/find.out
		echo "<br>"
		echo "<INPUT type="submit" value="ADDING">"
		echo -n "</FORM>"
		;;
	*)
		if [ "$VAL" = "FPATH" -o "$VAL" = "APATH" ] ; then
			echo "<br>"
		else
			message_info
		fi
		;;
esac
case $VAL in
		FPATH)
			#echo "${FPATH}" >> /tmp/myHD_shared.tmp 
			if [ "$FPATH" = "0" ] ; then
				echo "${RT005}"
				echo "<br>"
			else
				echo "${RT006} $(sed -n "${FPATH}p" < /usr/local/AppCentral/${NS_HOST}/fstab_include)"
				echo "<br>"				
				/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh remove_include_folder ${FPATH}
				echo "<br>"
				echo "done"
			fi
			message_info
			;;
		APATH)
			if [ "$APATH" = "0" ] ; then
				echo "NOTHING to do you check CANCEL"
				echo "<br>"
			else
				echo "${RT007} $(sed -n "${APATH}p" < /tmp/${NS_HOST}_find.out)"
				echo "<br>"
				/usr/builtin/bin/sudo -u root /usr/local/AppCentral/${NS_HOST}/${NS_HOST}.sh add_include_folder ${APATH}
				echo "<br>"
				echo "done"
			fi
			message_info
			;;
		*)
			:
			;;
esac
        echo "<br>"
		echo -n "<a class="button-launch" href="apkg_mgr.cgi"><$BLEU>Return to ${NS_HOST} Main menu<$NC></a>"
		echo "<a class="button-launch" href="myhd_shared.cgi">Return to PAGE Menu</a>"
echo "</td>"
}

cat /usr/local/AppCentral/${NS_HOST}/www/entete.in
echo "<style type="text/css">"
cat /usr/local/AppCentral/${NS_HOST}/www/css.css
# cat /share/Web/apkg_mgr/css_menu.css
echo "</style>"
echo "</head>"
echo "<body>"

echo "<h1>${TT001}</h1>"
if [ -z "$HTTP_REFERER" ] ; then
        echo "<p>${ER001}</p>"
        echo "<br><br>"
else
	# for debugecho "<b> ::::::: "$HTTP_REFERER""
	echo "$HTTP_REFERER" | grep -q apkg_mgr.cgi 
	if [ $? -ne 0 ] ; then
		echo "$HTTP_REFERER" | grep -q myhd_shared.cgi 
		if [ $? -ne 0 ] ; then
			echo "<p>${ER002} $HTTP_REFERER</p>"
			echo "<br><br>"
			echo '</body>'
			echo '</html>'
			exit 0
		fi
	fi
fi

CONFIRM=""
PKG=${NS_HOST}
CONF=""
IFS='&'
### debug echo "${QUERY_STRING}"
set -- ${QUERY_STRING}
for i in "$@"
do
        case ${i%%=*} in
            LIST_F)
				CONF="LIST_F"
				VAL="${i#*=}"
			;;
            submit|ADD|SUPP)
				:
            ;;
			REMOVE_F)
				CONF="REMOVE_F"
				VAL="${i#*=}"
			;;
			ADD_F)
				CONF="ADD_F"
				VAL="${i#*=}"
			;;
			FPATH)
				VAL="FPATH"
				FPATH="$(echo "${i#*=}" | sed 's/%2F/\//g')"
			;;
			APATH)
				VAL="APATH"
				APATH="$(echo "${i#*=}" | sed 's/%2F/\//g')"
			;;
            *)
                echo "<b>ERROR</b>: Unknown option '${i}'"
                echo "<br><br>"
                echo "<a class="button-link" href="apkg_mgr.cgi"><$BLEU>${BU001}<$NC></a>"
                echo '</body>'
                echo '</html>'
                exit 1
            ;;
        esac
done

echo '<table border="2" cellpadding="0" cellspacing="0" style="width:1366px">'
echo '<tr><th width=200px> Menu </th><th> Actions </th></tr>'
        fill_col_gauche
        fill_col_droite
echo '</table>'
#
echo '</body>'
echo '</html>'
